 /////////////////////////
 //--Read Config Files--//
 /////////////////////////
 SetupConfig()
 {
	//Set Up Config Files
	new PokeDir[128];
	Poke_FileName( F_PokeDir, PokeDir );

	if( !dir_exists(PokeDir) )
		mkdir(PokeDir);
 }
 Poke_FileName( PokeFiles:filenum, _File[], len=127 )
 {
	static PokeDir[128];
	if(!PokeDir[0]){
		get_configsdir(PokeDir,127);
		add(PokeDir,127,"/pokemon");
	}
	switch( filenum )
	{
		case F_PokeDir:		formatex(_File,len,	"%s/"				,PokeDir);
		case F_PokeConfig:	formatex(_File,len,	"%s/pokemod.cfg"	,PokeDir);
		case F_Pokemon:		formatex(_File,len,	"%s/pokemon.cfg"	,PokeDir);
		case F_Items:		formatex(_File,len,	"%s/items.cfg"		,PokeDir);
		case F_Pokedex:		formatex(_File,len,	"%s/pokedex.txt"	,PokeDir);
		case F_Safari:		formatex(_File,len,	"%s/safari.cfg"		,PokeDir);
		case F_PokeMaps:	formatex(_File,len,	"%s/maps.cfg"		,PokeDir);
		case F_XPs:			formatex(_File,len,	"%s/xp_table.ini"	,PokeDir);
	}
	return true;
 }
 public LoadConfig()
 {
	new PokeFile[128];
	get_localinfo("amxx_vault",g_VaultFile,127);

	//Load Config Files

	Poke_FileName( F_PokeConfig, PokeFile);
	if( file_exists(PokeFile) ) {
		server_cmd("exec %s",PokeFile);
		SearchCvars();
	}
	else {
		poke_error("**WARNING** PokeMod Config File not found, making default configs");
		ResetConfig();
	}

	Poke_FileName( F_Pokemon, PokeFile);
	if( !file_exists(PokeFile) ){
		poke_error("**WARNING** PokeMod Pokemon Properties File not found, making default");
		ResetPokemon();
	}
	Poke_FileName( F_Items, PokeFile);
	if( !file_exists(PokeFile) ){
		poke_error("**WARNING** PokeMod Items File not found, making default");
		ResetPokemart();
	}
	Poke_FileName( F_Pokedex, PokeFile);
	if( !file_exists(PokeFile) ){
		poke_error("**WARNING** PokeMod Pokedex not found, making default");
		Make_Pokedex();
	}
	Poke_FileName( F_Safari, PokeFile);
	if( !file_exists(PokeFile) ){
		poke_error("**WARNING** PokeMod Safari file not found, making default");
		ResetSafari();
	}
 }
 public ResetConfig()
 {
	new PokeFile[128];
	Poke_FileName( F_PokeConfig, PokeFile);

	if(file_exists(PokeFile))
		delete_file(PokeFile);

	write_file(PokeFile,	"//CVARS for PokeMod, these are loaded every map change",-1);
	write_file(PokeFile,	EMPTY, -1);

	for(new i=0; i<MAX_CVARS; i++)
		set_ppcvar_line(i, cvar_default[i]);

	write_file(PokeFile,	EMPTY, -1);
	write_file(PokeFile,	"echo \"PokeMod - Successfully Loaded PokeMod Config File\" ",-1);
 }

 public ResetPokemart()
 {
	new PokeFile[128];
	Poke_FileName( F_Items, PokeFile);

	if(file_exists(PokeFile))
		delete_file(PokeFile);

	write_file(PokeFile,	"// Note - Do not edit here unless you know what your doing, otherwise use pm_pokemart",-1)
	write_file(PokeFile,	"// Price = 0 (No one can buy) Price = -# (Only Admin can buy)",-1)
	write_file(PokeFile,	"// To make an item Group, place the group name in {} before the items",-1)
	write_file(PokeFile,	"// Put items then it's price, then it's properties.",-1)
	write_file(PokeFile,	"// Put pokemon name then it's price.",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"// Item Properties:",-1)
	write_file(PokeFile,	"//  \"a\" - heal item - followed by how much to heal. use -1 for full health",-1)
	write_file(PokeFile,	"//  \"b\" - catch item - followed by chance to catch",-1)
	write_file(PokeFile,	"//  \"c\" - removes all statuses",-1)
	write_file(PokeFile,	"//  \"d\" - removes burn status",-1)
	write_file(PokeFile,	"//  \"e\" - removes frozen status",-1)
	write_file(PokeFile,	"//  \"f\" - removes paralyze status",-1)
	write_file(PokeFile,	"//  \"g\" - removes asleep status",-1)
	write_file(PokeFile,	"//  \"h\" - removes slow status",-1)
	write_file(PokeFile,	"//  \"i\" - removes poison status",-1)
	write_file(PokeFile,	"//  \"j\" - teleports you to spawn",-1)
	write_file(PokeFile,	"//  \"k\" - give item to a pokemon (for evolution)",-1)
	write_file(PokeFile,	"//  \"l\" - extra pokedamage - followed by additional damage",-1)
	write_file(PokeFile,	"//  \"m\" - extra damage - followed by additional damage",-1)
	write_file(PokeFile,	"//  \"n\" - extra armor - followed by additional armor",-1)
	write_file(PokeFile,	"//  \"o\" - extra speed - followed by additional speed",-1)
	write_file(PokeFile,	"//  \"p\" - extra maxhp - followed by additional maxhp",-1)
	write_file(PokeFile,	"//  \"q\" - can't be bought",-1)
	write_file(PokeFile,	"//  \"r\" - evolution - followed by pokemon to evolve into",-1)
	write_file(PokeFile,	"//  \"s\" - levels a pokemon",-1)
	write_file(PokeFile,	"//  \"t\" - item trader - followed by item to recieve",-1)
	write_file(PokeFile,	"//  \"u\" - bicycle - followed by additional speed",-1)
	write_file(PokeFile,	"//  \"v\" - silph scope - allows you to see ghost pokemon",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"//  \"x\" - no drop - players don't drop this item when they die",-1)
	write_file(PokeFile,	"//  \"y\" - max amount - followed by max amount of this item players can have",-1)
	write_file(PokeFile,	"//  \"z\" - disable default use - disables default pokemod use of an item",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"// Examples:",-1)
	write_file(PokeFile,	"//  PokeBall 200 b 20",-1)
	write_file(PokeFile,	"//  Potion 300 a 20",-1)
	write_file(PokeFile,	"//  Antidote 100 i",-1)
	write_file(PokeFile,	"//  Full_Restore 3000 a -1 c",-1)
	write_file(PokeFile,	"//  Calcium 9800 l 10",-1)
	write_file(PokeFile,	"//  Fire_Stone 2100 k",-1)
	write_file(PokeFile,	"//  Nugget 10000 q",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"{Pokeballs}",-1)
	write_file(PokeFile,	"PokeBall 200 b 20",-1)
	write_file(PokeFile,	"Great_Ball 600 b 40",-1)
	write_file(PokeFile,	"Ultra_Ball 1200 b 80",-1)
	write_file(PokeFile,	"Master_Ball -16000 b 10000",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"{Items}",-1)
	write_file(PokeFile,	"Potion 300 a 20",-1)
	write_file(PokeFile,	"Antidote 100 i",-1)
	write_file(PokeFile,	"Awakening 200 g",-1)
	write_file(PokeFile,	"Burn_Heal 200 d",-1)
	write_file(PokeFile,	"Ice_Heal 250 e",-1)
	write_file(PokeFile,	"Paralyze_Heal 250 f",-1)
	write_file(PokeFile,	"Escape_Rope 550 j",-1)
	write_file(PokeFile,	"Full_Heal 600 c",-1)
	write_file(PokeFile,	"Super_Potion 700 a 70",-1)
	write_file(PokeFile,	"Full_Restore 3000 a -1 c",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"{Boosts}",-1)
	write_file(PokeFile,	"Calcium 9800 l 10",-1)
	write_file(PokeFile,	"Carbos 9800 o 50",-1)
	write_file(PokeFile,	"HP_Up 9800 p 25",-1)
	write_file(PokeFile,	"Iron 9800 n 50",-1)
	write_file(PokeFile,	"Protein 9800 m 5",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"{Stones}",-1)
	write_file(PokeFile,	"Fire_Stone 2100 k",-1)
	write_file(PokeFile,	"Leaf_Stone 2100 k",-1)
	write_file(PokeFile,	"Moon_Stone 2100 k",-1)
	write_file(PokeFile,	"Thunder_Stone 2100 k",-1)
	write_file(PokeFile,	"Water_Stone 2100 k",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"{Other}",-1)
	write_file(PokeFile,	"Nugget 10000 q",-1)
	write_file(PokeFile,	"Old_Amber 5000 q r aerodactyl",-1)
	write_file(PokeFile,	"Rare_Candy 16000 k q s",-1)
	write_file(PokeFile,	"Bicycle 0 q u 200",-1)
	write_file(PokeFile,	"Bike_Voucher 5000 q t Bicycle",-1)
	write_file(PokeFile,	"Silph_Scope 5000 v",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"Bulbasaur 16000", -1)
	write_file(PokeFile,	"Charmander 16000", -1)
	write_file(PokeFile,	"Squirtle 16000", -1)
	write_file(PokeFile,	"Pikachu 16000", -1)
 }
 public ResetPokemon()
 {
	new PokeFile[128];
	Poke_FileName( F_Pokemon, PokeFile);

	if(file_exists(PokeFile))
		delete_file(PokeFile)
	write_file(PokeFile,	"// Note - Do not edit here unless you know what your doing",-1)
	write_file(PokeFile,	"// Note2 - Do not edit the flags \"abcdef\" unless you have custom skills",-1)
	write_file(PokeFile,	"// Put pokemon name then it's properties, then skill time, then evolutions.",-1)
	write_file(PokeFile,	"// Skill times must have a '.' If no time specified, 1.0 will be used.",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"// Pokemon Properties:",-1)

	write_file(PokeFile,	"//  \"a\" - uses a skill that requires pressing a button",-1)
	write_file(PokeFile,	"//  \"b\" - uses a skill that is used automatically",-1)
	write_file(PokeFile,	"//  \"c\" - uses a skill that isn't used all at once",-1)
	write_file(PokeFile,	"//  \"d\" - uses a skill that needs charging before use",-1)
	write_file(PokeFile,	"//  \"e\" - uses a skill that requires touching players",-1)
	write_file(PokeFile,	"//  \"f\" - uses a skill that upgrades previous skill",-1)
	write_file(PokeFile,	"//  \"g\" - global - doesn't have to be active to use skill",-1)
	write_file(PokeFile,	"//  \"h\" - isn't an evolved form of another pokemon",-1)
	write_file(PokeFile,	"//  \"i\" - evolves - followed by level number, TRADE, or item name",-1)
	write_file(PokeFile,	"//                  - then followed by the pokemon it should evolve into",-1)
	write_file(PokeFile,	"//  \"j\" - special - pokemon follows special flags for capturing",-1)
	write_file(PokeFile,	"//  \"k\" - grass pokemon",-1)
	write_file(PokeFile,	"//  \"l\" - fire pokemon",-1)
	write_file(PokeFile,	"//  \"m\" - water pokemon",-1)
	write_file(PokeFile,	"//  \"n\" - rock pokemon",-1)
	write_file(PokeFile,	"//  \"o\" - electric pokemon",-1)
	write_file(PokeFile,	"//  \"p\" - psychic pokemon",-1)
	write_file(PokeFile,	"//  \"q\" - bug pokemon",-1)
	write_file(PokeFile,	"//  \"r\" - poison pokemon",-1)
	write_file(PokeFile,	"//  \"s\" - ghost pokemon",-1)
	write_file(PokeFile,	"//  \"t\" - normal pokemon",-1)
	write_file(PokeFile,	"//  \"u\" - ice pokemon",-1)
	write_file(PokeFile,	"//  \"v\" - fighting pokemon",-1)
	write_file(PokeFile,	"//  \"w\" - ground pokemon",-1)
	write_file(PokeFile,	"//  \"x\" - flying pokemon",-1)
	write_file(PokeFile,	"//  \"y\" - dragon pokemon",-1)
	write_file(PokeFile,	"//  \"z\" - disable default skill",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"// Example:",-1)
	write_file(PokeFile,	"//Bulbasaur ahikr 10.0 16 Ivysaur",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"Bulbasaur ahikr 10.0 16 Ivysaur",-1)
	write_file(PokeFile,	"Ivysaur bikr 0.0 32 Venusaur",-1)
	write_file(PokeFile,	"Venusaur ackr 15.0",-1)
	write_file(PokeFile,	"Charmander bhil 0.0 16 Charmeleon",-1)
	write_file(PokeFile,	"Charmeleon bfil 0.0 36 Charizard",-1)
	write_file(PokeFile,	"Charizard alx 5.0",-1)
	write_file(PokeFile,	"Squirtle achim 16 Wartortle",-1)
	write_file(PokeFile,	"Wartortle acfim 0.0 36 Blastoise",-1)
	write_file(PokeFile,	"Blastoise acfm 0.0",-1)
	write_file(PokeFile,	"Caterpie bhiq 0.0 7 Metapod",-1)
	write_file(PokeFile,	"Metapod aim 5.0 10 Butterfree",-1)
	write_file(PokeFile,	"Butterfree aqx",-1)
	write_file(PokeFile,	"Pidgey ahitx 10.0 18 Pidgeotto",-1)
	write_file(PokeFile,	"Pidgeotto afitx 36 Pidgeot",-1)
	write_file(PokeFile,	"Pidgeot atx 0.0",-1)
	write_file(PokeFile,	"Rattata bhit 20 Raticate",-1)
	write_file(PokeFile,	"Raticate bft",-1)
	write_file(PokeFile,	"Ekans bhir 22 Arbok",-1)
	write_file(PokeFile,	"Arbok ar",-1)
	write_file(PokeFile,	"Pikachu achio 15.0 Thunder_Stone Raichu",-1)
	write_file(PokeFile,	"Raichu ao 15.0",-1)
	write_file(PokeFile,	"Zubat behirx 22 Golbat",-1)
	write_file(PokeFile,	"Golbat befrx",-1)
	write_file(PokeFile,	"Venonat ahiqr 10.0 30 Venomoth",-1)
	write_file(PokeFile,	"Venomoth afqr",-1)
	write_file(PokeFile,	"Meowth bghit 0.0 28 Persian",-1)
	write_file(PokeFile,	"Persian bt",-1)
	write_file(PokeFile,	"Growlithe achil 15.0 Fire_Stone Arcanine",-1)
	write_file(PokeFile,	"Arcanine al 15.0",-1)
	write_file(PokeFile,	"Poliwag behim 25 Poliwhirl",-1)
	write_file(PokeFile,	"Poliwhirl befim Water_Stone Poliwrath",-1)
	write_file(PokeFile,	"Poliwrath befmv",-1)
	write_file(PokeFile,	"Abra ahip 10.0 16 Kadabra",-1)
	write_file(PokeFile,	"Kadabra aip 10.0 TRADE Alakazam",-1)
	write_file(PokeFile,	"Alakazam bgp",-1)
	write_file(PokeFile,	"Bellsprout ahikr 5.0 21 Weepinbell",-1)
	write_file(PokeFile,	"Weepinbell bikr Leaf_Stone Victreebel",-1)
	write_file(PokeFile,	"Victreebel ackr",-1)
	write_file(PokeFile,	"Geodude bhinw 25 Graveler",-1)
	write_file(PokeFile,	"Graveler ainw 5.0 TRADE Golem",-1)
	write_file(PokeFile,	"Golem anw 15.0",-1)
	write_file(PokeFile,	"Slowpoke achimp 15.0 37 Slowbro",-1)
	write_file(PokeFile,	"Slowbro afmp",-1)
	write_file(PokeFile,	"Doduo bghitx 0.0 31 Dodrio",-1)
	write_file(PokeFile,	"Dodrio bgtx 0.0",-1)
	write_file(PokeFile,	"Grimer bhir 0.0 35 Muk",-1)
	write_file(PokeFile,	"Muk bgr",-1)
	write_file(PokeFile,	"Gastly bhirs 0.0 25 Haunter",-1)
	write_file(PokeFile,	"Haunter airs 15.0 TRADE Gengar",-1)
	write_file(PokeFile,	"Gengar ars",-1)
	write_file(PokeFile,	"Onix ahnw 5.0",-1)
	write_file(PokeFile,	"Voltorb ahio 33 Electrode",-1)
	write_file(PokeFile,	"Electrode bgfo",-1)
	write_file(PokeFile,	"Koffing bhir 0.0 35 Weezing",-1)
	write_file(PokeFile,	"Weezing bfr 0.0",-1)
	write_file(PokeFile,	"Chansey aht 10.0",-1)
	write_file(PokeFile,	"Tangela bghk 0.0",-1)
	write_file(PokeFile,	"Staryu ahim 15.0 Water_Stone Starmie",-1)
	write_file(PokeFile,	"Starmie bgmp",-1)
	write_file(PokeFile,	"MrMime ahp 5.0",-1)
	write_file(PokeFile,	"Scyther ahqx 15.0",-1)
	write_file(PokeFile,	"Jynx ahpu 15.0",-1)
	write_file(PokeFile,	"Electabuzz bho",-1)
	write_file(PokeFile,	"Magmar achl 15.0",-1)
	write_file(PokeFile,	"Pinsir bhq",-1)
	write_file(PokeFile,	"Magikarp ahim 20 Gyarados",-1)
	write_file(PokeFile,	"Gyarados amx 17.5",-1)
	write_file(PokeFile,	"Porygon acht 10.0",-1)
	write_file(PokeFile,	"Aerodactyl bnx",-1)
	write_file(PokeFile,	"Snorlax acht 0.0",-1)
	write_file(PokeFile,	"Articuno achjux 10.0",-1)
	write_file(PokeFile,	"Zapdos ahjox 15.0",-1)
	write_file(PokeFile,	"Moltres ahjlx 15.0",-1)
	write_file(PokeFile,	"Dratini bhiy 30 Dragonair",-1)
	write_file(PokeFile,	"Dragonair biy 5.0 55 Dragonite",-1)
	write_file(PokeFile,	"Dragonite acxy 25.0",-1)
	write_file(PokeFile,	"Mewtwo bhjp 0.0",-1)
	write_file(PokeFile,	"Mew achjp 15.0",-1)

 }
 public ResetSafari()
 {
	new PokeFile[128];
	Poke_FileName( F_Safari, PokeFile);

	if(file_exists(PokeFile))
		delete_file(PokeFile)

	write_file(PokeFile,	"// Note - Do not edit here unless you know what your doing, otherwise use pm_safari",-1)
	write_file(PokeFile,	"// Place pokemon name then their level.",-1)
	write_file(PokeFile,	"// Level = 0 (No one can use) Level = -# (Only Admin can use)",-1)
	write_file(PokeFile,	"// Level = -1000 (Disabled entirely)",-1)

	write_file(PokeFile,	"Bulbasaur 1",-1)
	write_file(PokeFile,	"Charmander 1",-1)
	write_file(PokeFile,	"Squirtle 1",-1)
	write_file(PokeFile,	"Pikachu 1",-1)

	write_file(PokeFile,	"Articuno 1",-1)
	write_file(PokeFile,	"Zapdos 1",-1)
	write_file(PokeFile,	"Moltres 1",-1)
	write_file(PokeFile,	"Mew 1",-1)
	write_file(PokeFile,	"Mewtwo 1",-1)
 }

 public ResetMapsConfig()
 {
	new PokeFile[128];
	Poke_FileName( F_PokeMaps, PokeFile);

	if(file_exists(PokeFile))
		delete_file(PokeFile)

	write_file(PokeFile,	"// Note - Only add things here if you know what you are doing.",-1)
	write_file(PokeFile,	"// When adding map specific configs, do the following:",-1)
	write_file(PokeFile,	"//  1. list the map name in brakets",-1)
	write_file(PokeFile,	"//  2. list things you want under it",-1)
	write_file(PokeFile,	"//  3. do not put comments in the front of the line ( // or ; )",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"// Examples:",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"//[de_dust]",-1)
	write_file(PokeFile,	"//-disabled",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"//[as_*]",-1)
	write_file(PokeFile,	"//-skills_off",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"//[dod_*]",-1)
	write_file(PokeFile,	"//pm_pokemart potion 1",-1)
 }
 
 public ReadPokemon()
 {
	new PokeFile[128];
	Poke_FileName( F_Pokemon, PokeFile);
	new Data[255], i, charnum, size = file_size(PokeFile, 1)
	new Left[NAME_LENGTH], Right[151]
	new poke, evolve_num

	for(i=0; i<size; i++){
		read_file(PokeFile,i,Data,255,charnum)

		if(strlen(Data)<2 || Data[0] == ';' || equali(Data,"//",2))
			continue

		strbreak(Data, Left, NAME_LENGTH-1, Right, 150)
		remove_quotes(Left)

		poke = NameToPoke(Left, true)
		if( !poke ){
			continue
		}

		PokeInfo[poke] = 0
		evolve_num = 0

		strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
		remove_quotes(Left)
		PokeInfo[poke] |= read_flags(Left)

		if( containi(Right, ".") != -1){
			strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
			PokeDelay[poke] = str_to_float(Left)
		}
		else
			PokeDelay[poke] = 1.0

		if( EvoPoke(poke) )
		{
			while( Right[0] ){
				strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
				remove_quotes(Left)
				PokeEvolve[evolve_num][poke] = str_to_num(Left)
				if( !PokeEvolve[evolve_num][poke] ){
					if(equali(Left, "TRADE"))
						PokeEvolve[evolve_num][poke] = TRADE_EVOLVE
					else
						PokeEvolve[evolve_num][poke] = -1*NameToItem(Left) // negative so we know it isn't a level
				}
				if( PokeEvolve[evolve_num][poke] ){
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					PokeEvolveTo[evolve_num][poke] = NameToPoke(Left)
					if( PokeEvolveTo[evolve_num][poke] )
						evolve_num++
					else
						 PokeEvolve[evolve_num][poke] = 0
				}
			}
		}
	}
 }

 public ReadXPs()
 {
	new PokeFile[128];
	Poke_FileName( F_XPs, PokeFile);

	if( !file_exists(PokeFile) ){
		poke_error("**WARNING** PokeMod XP Table not found, making default")
		ResetXPs();
	}

	new Data[256], i, charnum, size = file_size(PokeFile, 1);
	new Left[11];
	new last_level;

	for(i=0; i<size; i++){
		read_file(PokeFile,i,Data,255,charnum);
		if( strlen(Data) < 2 )
			continue;

		strbreak(Data, Left, 10, Data, 255);

		while( Left[0] != ';' && !equali(Left,"//",2) )
		{
			if( last_level >= MAX_LEVELS ){
				//we're going to end the while loop, but we'll need to end the for loop also
				i = size;
				break;
			}

			PokeLevels[last_level] = str_to_num(Left);

			if(last_level && PokeLevels[last_level-1] >= PokeLevels[last_level]){

				poke_error( "ERROR in XP File: level %d(%d) >= level %d(%d)",last_level-1,PokeLevels[last_level-1],last_level,PokeLevels[last_level] )

				//we're going to end the while loop, but we'll need to end the for loop also
				i = size;
				break;

			}
			else
				last_level++

			strbreak(Data, Left, 10, Data, 255);
		}
	}

	//set first level to 0 xp
	PokeLevels[0] = 0;
	TotalLevels = last_level;

	debugMessage( _, 1, "Loaded %d levels", last_level);
 }
 
 public ResetXPs()
 {
	new PokeFile[128];
	Poke_FileName( F_XPs, PokeFile);

	if(file_exists(PokeFile))
		delete_file(PokeFile)

	write_file(PokeFile,	"// Just place the level XPs how you want",-1)
	write_file(PokeFile,	"// Note - Even if you don't set it, level 1 will always be 0 xp.",-1)
	write_file(PokeFile,	EMPTY,-1)
	write_file(PokeFile,	"0	10	20	30	50	70	100	130	170	210	//1-10",-1)
	write_file(PokeFile,	"260	310	370	430	500	570	650	730	820	910	//11-20",-1)
	write_file(PokeFile,	"1010	1110	1220	1330	1450	1570	1700	1830	1970	2110	//21-30",-1)
	write_file(PokeFile,	"2260	2410	2570	2730	2900	3070	3250	3430	3620	3810	//31-40",-1)
	write_file(PokeFile,	"4010	4210	4420	4630	4850	5070	5300	5530	5770	6010	//41-50",-1)
	write_file(PokeFile,	"6260	6510	6770	7030	7300	7570	7850	8130	8420	8710	//51-60",-1)
	write_file(PokeFile,	"9010	9310	9620	9930	10250	10570	10900	11230	11570	11910	//61-70",-1)
	write_file(PokeFile,	"12260	12610	12970	13330	13700	14070	14450	14830	15220	15610	//71-80",-1)
	write_file(PokeFile,	"16010	16410	16820	17230	17650	18070	18500	18930	19370	19810	//81-90",-1)
	write_file(PokeFile,	"20260	20710	21170	21630	22100	22570	23050	23530	24020		//91-99",-1)
 }
 
 SearchCvars()
 {
	for(new i=0; i<MAX_CVARS; i++)
		if(get_ppcvar_line(i) == -1)
			set_ppcvar_line(i, cvar_default[i]);
 }
 