
 //////////////////////////////////////
 //  When someone presses +pokeitem  //
 //////////////////////////////////////
 public pokeitem_down(id)
 {
	debugMessage(id,2," pressed +pokeitem")

	g_isItemed[id] = true
	new aid, body
	get_user_aiming(id, aid, body)
	if(!is_user_alive(id) || EntIsPC(aid)){
		ShopMenu(id)
		return PLUGIN_HANDLED
	}

	ItemUseMenu(id)
	return PLUGIN_HANDLED
 }

 ///////////////////////////////////////
 //  When someone releases +pokeitem  //
 ///////////////////////////////////////
 public pokeitem_up(id)
 {
	g_isItemed[id] = false
	return PLUGIN_HANDLED
 }

 ////////////////////////////////////////////////////
 //  Buy an item from oak or through say commands  //
 ////////////////////////////////////////////////////
 buy_item(id, item, num=1)
 {
	new cost, money

	if(!PMon()){
		client_print(id, print_chat, "%s PokeMod is currently disabled.",PREFIX)
		return PLUGIN_HANDLED
	}
	if( !BuyCheck(id) ){
		#if MOD==CS
		client_print(id, print_chat, "%s You are not close enough to Oak or a buyzone.",PREFIX)
		#else
		client_print(id, print_chat, "%s You are not close enough to Oak.",PREFIX)
		#endif
		return PLUGIN_HANDLED
	}
	if( item >= ItemsCreated ){
		client_print(id, print_chat, "%s Invalid item to buy.",PREFIX)
		return PLUGIN_HANDLED
	}
	if( ItemInfo[item] & II_SPECIAL ){
		client_print(id, print_chat, "%s Unable to buy that item.",PREFIX)
		return PLUGIN_HANDLED
	}
	#if MAX_ITEM_TOTAL > 0
	if( TotalItems(id)+num > MAX_ITEM_TOTAL){
		num = MAX_ITEM_TOTAL - TotalItems(id);
		if( !num )
			client_print(id, print_chat, "%s You have reached the max amount of items you can buy.",PREFIX)
		else
			client_print(id, print_chat, "%s You can only buy %d more of items.",PREFIX,num)
		return PLUGIN_HANDLED
	}
	#endif
	#if MAX_ITEM_AMOUNT > 0
	if( Item[id][item]+num > MAX_ITEM_AMOUNT){
		num = MAX_ITEM_AMOUNT - Item[id][item];
		if( !num )
			client_print(id, print_chat, "%s You have reached the max amount of this item that you can buy.",PREFIX)
		else
			client_print(id, print_chat, "%s You can only buy %d more of this item.",PREFIX,num)
		return PLUGIN_HANDLED
	}
	#endif
	if( ItemInfo[item]&II_MAX && Item[id][item]+num > ItemMax[item] ){
		num = ItemMax[item] - Item[id][item];
		if( !num )
			client_print(id, print_chat, "%s You have reached the max amount of this item that you can buy.",PREFIX)
		else
			client_print(id, print_chat, "%s You can only buy %d more of this item.",PREFIX,num)
		return PLUGIN_HANDLED
	}

	if(PokeBuyForward > -1)
	{
		new functionReturn
		ExecuteForward(PokeBuyForward, functionReturn, id, item, num)

		// Forward will return the highest value, don't return 1 or 2 in function cause of return handled or handled_main
		// and 0 is used by continue and invalid return.
		if(functionReturn==PLUGIN_HANDLED)	//if something else did handle it, let's stop here.
		{
				return PLUGIN_HANDLED
		}
	}

	new tempcost = CostOfItem(item)
	if(tempcost<0 && !is_user_admin(id)){//only admins can buy it
		client_print(id, print_center,"Only Admins may purchase this!")
		return PLUGIN_HANDLED
	}
	if(tempcost==0){
		client_print(id, print_center,"This item is disabled")
		return PLUGIN_HANDLED
	}

	cost = abs(tempcost)*num
	money = Money(id)

	if(money < cost){//costs too much
		client_print(id, print_center,"You have insufficient funds!")
		return PLUGIN_HANDLED
	}

	new iname[NAME_LENGTH]
	ItemToName(item, iname)

	if(is_user_bot(id))
		BotSay(id, BOT_BOUGHT_ITEM, num, item)
	else
		client_print(id, print_chat,"%s You bought %d %s%s!",PREFIX, num, iname, num>1?"s":EMPTY)

	Item[id][item] += num
	Pay(id, -1*(cost))

	if(ItemInfo[item] & II_MAXHP){
		CheckMaxHP(id)
		Heal(id, ItemMaxHP[num]*num)
	}
	if( ItemInfo[item] & II_ARMOR ){
		Repair(id, ItemArmor[item]*num)
	}
	SetSpeed(id)

	return PLUGIN_HANDLED
 }

 //////////////////////////////
 //  Buy a pokemon from oak  //
 //////////////////////////////
 public buy_poke(parm[])
 {
	new cost = 0, money, id = parm[0], poke = parm[1], pname[NAME_LENGTH]

	if(!PMon()){
		client_print(id, print_chat, "%s PokeMod is currently disabled.",PREFIX)
		return PLUGIN_HANDLED
	}
	if(!BuyCheck(id)){
		#if MOD==CS
		client_print(id, print_chat, "%s You are not close enough to Oak or a buyzone.",PREFIX)
		#else
		client_print(id, print_chat, "%s You are not close enough to Oak.",PREFIX)
		#endif
		return PLUGIN_HANDLED
	}

	PokeToName(poke, pname)

	switch(AvailableSlot(id, poke))
	{
		case 0:{
			client_print(id, print_chat, "%s Something went wrong when you tried to buy a %s.",PREFIX,pname)
			return PLUGIN_HANDLED
		}
		case -1:{
			client_print(id, print_chat, "%s You have too many pokemon. Send one to Bill's PC or release one.",PREFIX)
			return PLUGIN_HANDLED
		}
		case -2:{
			client_print(id, print_chat, "%s You already have a %s. Buy another pokemon.",PREFIX,pname)
			return PLUGIN_HANDLED
		}
	}

	if(PokeBuyPokeForward > -1)
	{
		new functionReturn
		ExecuteForward(PokeBuyPokeForward, functionReturn, id, poke)

		// Forward will return the highest value, don't return 1 or 2 in function cause of return handled or handled_main
		// and 0 is used by continue and invalid return.
		if(functionReturn==PLUGIN_HANDLED)	//if something else did handle it, let's stop here.
		{
				return PLUGIN_HANDLED
		}
	}

	cost = CostOfPoke(poke)
	money = Money(id)

	if(cost<0 && !is_user_admin(id)){//only admins can buy it
		client_print(id, print_center,"Only Admins may purchase this!")
		return PLUGIN_HANDLED
	}
	if(cost==0){
		client_print(id, print_center,"This item is disabled")
		return PLUGIN_HANDLED
	}

	if(money < abs(cost)){//costs too much
		client_print(id, print_center,"You have insufficient funds!")
		return PLUGIN_HANDLED
	}

	Pay(id, -1*abs(cost))
	client_print(id, print_chat,"%s You bought a level 1 %s.",PREFIX, pname)
	AddPoke(id, poke, 1)

	return PLUGIN_HANDLED
 }

 ///////////////////
 //  Use an item  //
 ///////////////////
 public UseItem(id, item)
 {
	if(!is_user_alive(id) || !PMon()) return PLUGIN_HANDLED

	//check turns into 1 if item is used, and 2 if soundcure should be played
	new check = 0

	new iname[NAME_LENGTH]
	ItemToName(item, iname)
	debugMessage(id,2,"used %s",iname)

	if( PokeItemForward > -1 )
	{
		new functionReturn
		ExecuteForward(PokeItemForward, functionReturn, id, item)

		// Forward will return the highest value, don't return 1 or 2 in function cause of return handled or handled_main
		// and 0 is used by continue and invalid return.
		if(functionReturn==PLUGIN_HANDLED)	//if something was handled, stop
		{
			return PLUGIN_HANDLED;
		}
	}

	if( ItemInfo[item] & II_DISABLE )
		return PLUGIN_HANDLED;

	if( ItemInfo[item] & II_HEAL ){
		if( Health(id) < maxhp[id] ){
			check = 2
			if( ItemHeal[item] == -1 )
				Heal(id, maxhp[id])
			else
				Heal(id, ItemHeal[item])
		}
	}
	if( ItemInfo[item] & II_REMEDY ){
		if( HasStatus(id) ){
			check = 2
			ResetStatus(id)
		}
		else if(!check) client_print(id,print_chat,"%s You do not have any status effects.",PREFIX)
	}
	if( ItemInfo[item] & II_POISON ){
		if(g_Status[id][STATUS_POISON]){
			check = 2
			RemoveStatus(id, STATUS_POISON)
		}
		else if(!check) client_print(id,print_chat,"%s You are not poisoned.",PREFIX)
	}
	if( ItemInfo[item] & II_ASLEEP ){
		if(g_Status[id][STATUS_ASLEEP]){
			check = 2
			unsleep(id)
		}
		else if(!check) client_print(id,print_chat,"%s You are not asleep.",PREFIX)
	}
	if( ItemInfo[item] & II_BURN ){
		if(g_Status[id][STATUS_BURN]){
			check = 2
			RemoveStatus(id, STATUS_BURN)
			stopFireSound(id)
		}
		else if(!check) client_print(id,print_chat,"%s You are not burnt.",PREFIX)
	}
	if( ItemInfo[item] & II_FROZEN ){
		if(g_Status[id][STATUS_FROZEN]){
			check = 2
			RemoveStatus(id, STATUS_FROZEN)
			SetSpeed(id)
		}
		else if(!check) client_print(id,print_chat,"%s You are not frozen.",PREFIX)
	}
	if( ItemInfo[item] & II_PARALYZE 
	||	ItemInfo[item] & II_SLOW	){
		if(g_Status[id][STATUS_PARALYZE] || g_Status[id][STATUS_SLOW]){
			check = 2
			RemoveStatus(id, STATUS_PARALYZE)
			RemoveStatus(id, STATUS_SLOW)
		}
		else if(!check) client_print(id,print_chat,"%s You are not paralyzed.",PREFIX)
	}
	if( ItemInfo[item] & II_ESCAPE ){
		check = 1
		EscapeRope(id, 1)
		if(is_user_bot(id)){
			start_heal(id)
		}
	}
	if( ItemInfo[item] & II_FOSSIL ) {

		if( NearOakCheck(id) > 0 ){
			new pname[NAME_LENGTH]
			PokeToName(ItemFossil[item], pname)
			switch( AvailableSlot(id, ItemFossil[item]) )
			{
				case 1:{
					new i = Slot(id)
					PlayersPoke[id][i] = ItemFossil[item]
					PlayersXP[id][i] = 1
					check = 1

					client_print(id, print_chat, "Prof. Oak: Here you go! Your %s is now a %s!", iname, pname)
				}
				case 0:
					client_print(id, print_chat, "Prof. Oak: Wild pokemon can't gain pokemon.")
				case -1:
					client_print(id, print_chat, "Prof. Oak: You have too many pokemon already.")
				case -2:
					client_print(id, print_chat, "Prof. Oak: You already have a %s.", pname)
			}
		}
		else
			client_print(id, print_chat, "%s You need to take your %s to Prof. Oak.", PREFIX, iname)
		if(!check) check = -1
	}
	if( ItemInfo[item] & II_BIKEV ) {
		if( NearOakCheck(id) > 0 ){
			new iname2[NAME_LENGTH]
			ItemToName(ItemItem[item], iname2)
			client_print(id,print_chat,"Prof. Oak: I traded your %s for a %s.", iname, iname2)
			Item[id][ItemItem[item]]++
			check = 1
		}
		else
			client_print(id, print_chat, "%s You need to take your %s to Prof. Oak.", PREFIX, iname)
		if(!check) check = -1
	}
	if( ItemInfo[item] & II_BIKE ) {
		if(g_Status[id][STATUS_BIKE]){
			RemoveStatus(id, STATUS_BIKE)
			client_print(id,print_chat,"%s You stopped riding your %s!",PREFIX, iname)
		}
		else{
			SetStatus(id, STATUS_BIKE)
			client_print(id,print_chat,"%s You started riding your %s!",PREFIX, iname)
		}
		SetSpeed(id)
		if(!check) check = -1
	}
	#if RARE_CANDY_MODE == 2 || RARE_CANDY_MODE == 3
	if( ItemInfo[item] & II_LEVEL ){
		PlayerGive[id] = item
		SetActionMenu( id, GIVE_ITEM )
		check = -1
	}
	#endif
	if( ItemInfo[item] & II_GIVE ){
		PlayerGive[id] = item
		SetActionMenu( id, GIVE_ITEM )
		check = -1
	}

	if( !check && ItemInfo[item] & II_CATCH )
		client_print(id,print_chat,"%s Pokeballs are automatically used when you kill someone.",PREFIX)

	if( !check
		&&	 ItemInfo[item] & II_PDAMAGE
		||	 ItemInfo[item] & II_DAMAGE
		||	 ItemInfo[item] & II_ARMOR
		||	 ItemInfo[item] & II_SPEED
		||	 ItemInfo[item] & II_MAXHP)
		client_print(id,print_chat,"%s Stat items are used automatically.",PREFIX)

	if(check > 0){
		Item[id][item]--
		client_print(id,print_chat,"%s You used a %s!",PREFIX, iname)

		if( check == 2 )
			soundcure(id)
	}
	else if( check > -1 )
		sounddeny(id)

	return PLUGIN_HANDLED
 }

 ////////////////////////////////////
 //  Returns if they have an item  //
 ////////////////////////////////////
 PokeItem(id)
 {
	if(!PMon()) return false

	for(new i = 0; i < ItemsCreated; i++){
		if(Item[id][i] > 0)
			return true
	}
	return false
 }

 //////////////////////////////////////
 //  Determines if id has this item  //
 //////////////////////////////////////
 HasPokeItem(id, item)
 {
	if(!PMon()) return 0

	if(Item[id][item] > 0)
		return Item[id][item]
	return 0
 }

 //////////////////////////////
 //  Teleport user to spawn  //
 //////////////////////////////
 public EscapeRope(id, num)
 {
	new entSpawn
	new Float:spawnAngle[3] 
	new Float:spawnOrigin[3]

	if(num > 0)
		if(!PassTest(id, 0))
			return PLUGIN_HANDLED

	for(new i=0 ; i < MAX_PLAYERS+1 ; i++){
		spawnPointsused[i] = false
	}

	if( pev_valid(id) ){
		new teamnum = Team(id)
		if(teamnum!=0)
			entSpawn = find_free_spawn(teamnum, spawnOrigin, spawnAngle, 1)
	}

	if (!entSpawn) 
	{
		// Didn't find a free spawn spot. Quit... 
		if(is_user_alive(id))
			client_print(id,print_chat,"%s You couldn't find a way out.",PREFIX)
		return PLUGIN_CONTINUE 
	}

	new origina[3]
	FVecIVec(spawnOrigin, origina)

	if(num>0){
		get_user_origin(id, origin[id])
		MakeLine(0,origin[id],origina,rope,0,0,20,7,0,139,59,19,255,0)
	}

	set_pev(id, pev_angles, spawnAngle)
	set_user_origin(id,origina)

	return PLUGIN_HANDLED
 }

 ///////////////////
 //  Gives items  //
 ///////////////////
 GiveItem(id, item, amount)
 {
	new itemname[NAME_LENGTH]

	ItemToName(item, itemname)

	#if MAX_ITEM_TOTAL > 0
	if( TotalItems(id)+amount > MAX_ITEM_TOTAL){
		amount = MAX_ITEM_TOTAL - TotalItems(id);
		if( !amount )
			return PLUGIN_HANDLED
	}
	#endif
	#if MAX_ITEM_AMOUNT > 0
	if( Item[id][item]+amount > MAX_ITEM_AMOUNT){
		amount = MAX_ITEM_AMOUNT - Item[id][item];
		if( !amount )
			return PLUGIN_HANDLED
	}
	#endif
	if( ItemInfo[item]&II_MAX && Item[id][item]+amount > ItemMax[item] ){
		amount = ItemMax[item] - Item[id][item];
		if( !amount )
			return PLUGIN_HANDLED
	}

	Item[id][item] += amount

	if(ItemInfo[item] & II_MAXHP)
		CheckMaxHP(id)
	if(ItemInfo[item] & II_SPEED)
		SetSpeed(id)

	client_print(id, print_chat, "%s You picked up %d %s",PREFIX, amount, itemname)
	return PLUGIN_HANDLED
 }

 ////////////////////
 //  Sell an item  //
 ////////////////////
 SellItem(id, item, num=1)
 {
	if( item >= MAX_ITEMS ){
		client_print(id, print_chat, "%s Invalid item to sell.",PREFIX)
		return
	}
	new itemname[NAME_LENGTH]
	ItemToName(item, itemname)
	if(num>HasPokeItem(id, item)){
		client_print(id, print_chat, "%s You do not have %d %s%s to sell.",PREFIX, num, itemname, num>1?"s":EMPTY)
		return
	}
	new sold_for = floatround(abs(CostOfItem(item, true))*SELLFACTOR)*num

	Pay(id, sold_for)
	Item[id][item] -= num

	if(ItemInfo[item] & II_MAXHP){
		CheckMaxHP(id)
		if(Health(id)>maxhp[id])
			Heal(id, 0)
	}
	if(ItemInfo[item] & II_SPEED)
		SetSpeed(id)

	client_print(id, print_chat, "%s You sold %d %s for $%d",PREFIX, num, itemname, sold_for)
 }

 /////////////////////////////////
 //  Removes items from player  //
 /////////////////////////////////
 public NoItems(id)
 {
	if(g_Status[id][STATUS_BIKE]){
		RemoveStatus(id, STATUS_BIKE)
		SetSpeed(id)
	}
	for(new apple = 0; apple < ItemsCreated ; apple++){
		Item[id][apple] = 0
	}

	return PLUGIN_HANDLED
 }

 CostOfItem(item, bool:is_item=true)
 {
	if(is_item)
		return ItemPrice[item]
	return ItemPrice[MAX_ITEMS+item]
 }
 CostOfPoke(poke)
	return CostOfItem(poke, false)

 public ResetItemCosts()
 {
	new PokeFile[128];
	Poke_FileName( F_Items, PokeFile);

	new Data[255], i, charnum, size = file_size(PokeFile, 1);
	new Left[NAME_LENGTH], Right[151];
	new item, icat, is_poke;

	ItemCatCreated = 0;
	ItemsCreated = 0;

	for(i=0; i<size; i++){
		read_file(PokeFile,i,Data,255,charnum)

		if(strlen(Data)<2 || Data[0] == ';' || equali(Data,"//",2))
			continue

		strbreak(Data, Left, NAME_LENGTH-1, Right, 150)
		remove_quotes(Left)

		if( Data[0] == '{' ){
			if(icat == MAX_ITYPE){
				debugMessage(_,_, "Max item categories reached. Cannot create category %s",Left)
				continue
			}

			icat = ItemCatCreated++
			replace(Left, NAME_LENGTH-1, "{", EMPTY)
			replace(Left, NAME_LENGTH-1, "}", EMPTY)
			copy(ItemCatName[icat], NAME_LENGTH-1, Left)

			continue;
		}

		is_poke = NameToPoke(Left, true)
		if( is_poke ){
			strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
			ItemPrice[ MAX_ITEMS + is_poke ] = str_to_num(Left)
			continue
		}

		if(item == MAX_ITEMS){
			debugMessage(_,_, "Max items reached. Cannot create item %s",Left)
			continue
		}

		//okay it isn't a pokemon, lets save the item name
		copy( ItemName[item], NAME_LENGTH-1, Left)
		replace_all( ItemName[item], NAME_LENGTH-1, "_", " ")

		//now lets get the price
		strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
		ItemPrice[ item ] = str_to_num(Left)

		ItemCat[item] = icat;
		ItemInfo[item] = 0;

		while( Right[0] && !equali(Right, "//", 2) ){
			strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
			remove_quotes(Left)
			ItemInfo[item] |= read_flags(Left)

			switch( Left[0] )
			{
				case 'a':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemHeal[item] = str_to_num(Left)
				}
				case 'b':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemCatch[item] = str_to_num(Left)
				}
				case 'l':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemPDamage[item] = str_to_num(Left)
				}
				case 'm':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemDamage[item] = str_to_num(Left)
				}
				case 'n':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemArmor[item] = str_to_num(Left)
				}
				case 'o':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemSpeed[item] = str_to_num(Left)
				}
				case 'p':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemMaxHP[item] = str_to_num(Left)
				}
				case 'r':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemFossil[item] = NameToPoke(Left)
				}
				case 't':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemItem[item] = NameToItem(Left)
					new iname[NAME_LENGTH]
					ItemToName(item, iname)
				}
				case 'u':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemSpeed[item] = str_to_num(Left)
				}
				case 'y':{
					strbreak(Right, Left, NAME_LENGTH-1, Right, 150)
					remove_quotes(Left)
					ItemMax[item] = str_to_num(Left)
				}
			}
		}
		item++
		ItemsCreated++
	}

	if(RegisterItemForward > -1)
	{
		new functionReturn;
		ExecuteForward(RegisterItemForward, functionReturn);
	}
 }
 public TradeItem(id, item, nid, num)
 {
	if( item < 0 || item >= ItemsCreated )
		return false;

	new iname[NAME_LENGTH];
	ItemToName(item, iname);

	if( num < 1 )
		num = 1;

	if(Item[id][item]>=num){
		new name[32], Nname[32];
		get_user_name(id, name, 31);
		get_user_name(nid, Nname, 31);

		#if MAX_ITEM_TOTAL > 0
		if( TotalItems(id)+num > MAX_ITEM_TOTAL){
			num = MAX_ITEM_TOTAL - TotalItems(id);
			if( !num ){
				client_print(id, print_chat, "%s %s cannot have any more items.", PREFIX, name);
				return false;
			}
		}
		#endif
		#if MAX_ITEM_AMOUNT > 0
		if( Item[id][item]+num > MAX_ITEM_AMOUNT){
			num = MAX_ITEM_AMOUNT - Item[id][item];
			if( !num ){
				client_print(id, print_chat, "%s %s cannot have any more of that item.", PREFIX, name);
				return false;
			}
		}
		#endif
		if( ItemInfo[item]&II_MAX && Item[id][item]+num > ItemMax[item] ){
			num = ItemMax[item] - Item[id][item];
			if( !num ){
				client_print(id, print_chat, "%s %s cannot have any more of that item.", PREFIX, name);
				return false;
			}
		}

		Item[nid][item] += num;
		Item[id][item] -= num;

		client_print(nid, print_chat, "%s %s gave you %d %s.", PREFIX, name, num, iname);
		client_print(id, print_chat, "%s You gave %d %s to %s.", PREFIX, num, iname, Nname);
		return true;
	}
	else
		client_print(id, print_chat, "%s You don't have %d %s%s to give.", PREFIX, num, iname, num>1?"s":EMPTY);
	return false;
 }
 HasSilphScope( id )
 {
	for( new i=0; i<ItemsCreated; i++)
		if( ItemInfo[i]&II_SCOPE && HasPokeItem( id, i ) )
			return i;
	return MAX_ITEMS;
 }
 TotalItems( id )
 {
	new total;
	for( new i=0; i<ItemsCreated; i++)
		total += Item[id][i];
	return total;
 }
 public Console_Pokemart(id)
 {
	new arg[32];
	read_argv(1,arg,31);
	new cat = NameToCat(arg);
	if( cat < 0 || cat >= ItemCatCreated ){
		if(arg[0])
			console_print(id, "%s Invalid Pokemart Shop.", PREFIX);
		cat = -1;
	}
	ShopMenu(id, cat);
	return PLUGIN_HANDLED;
 }
 #if AUTO_ITEMS > 0
 AutoItems(id)
 {
	if( PokeItem(id) ){
		#if AUTO_ITEMS == 1
		if(is_user_bot(id)){
		#endif

		new holder, hp
		hp = Health(id)

		for( holder = 0 ; holder < ItemsCreated ; holder++ ){

			if( !HasPokeItem(id,holder) || ItemInfo[holder] & II_DISABLE )
				continue
			if( ItemInfo[holder] & II_HEAL ){
				if( ItemHeal[holder] == -1 ){
					if( maxhp[id]-hp > maxhp[id]/2 ){
						UseItem(id, holder)
						break
					}
				}
				else if( maxhp[id]-hp >= ItemHeal[holder] ){
					hp += ItemHeal[holder]
					UseItem(id, holder)
				}
			}
		}

		#if AUTO_ITEMS == 1
		}
		#endif
	}
 }
 #endif

