 
 //////////////////////////////////////////
 //  Reset menus that are never changed  //
 //////////////////////////////////////////
 public ResetMenus()
 {
	ResetStartMenu()
	ResetHelpMenu()
	ResetSafariMenu()
 }
 
 /////////////////////
 //  Handles Menus  //
 /////////////////////
 public poke_menu_handler(id, menu, item)
 {
	if (item == MENU_EXIT)
	{
		debugMessage(id,2,"exited a menu=%d, item=%d, Action=%d",menu,item,Action[id])

		//menus we don't want to destroy
		if(Action[id]!=START && Action[id]!=SAFARI && Action[id]!=HELP)
			menu_destroy(menu)

		if(Action[id] == BILL){
			set_task(0.1,"PokeMenu",id)
			return PLUGIN_HANDLED
		}

		SetAction( id )
		return PLUGIN_HANDLED
	}

	new cmd[6], iName[64]
	new access, callback, key
	menu_item_getinfo(menu, item, access, cmd,5, iName, 63, callback)

	key = str_to_num(cmd)

	debugMessage(id,2,"used a menu=%d, item=%s, Action=%d, key=%d",menu,iName,Action[id],key)

	//switch for different menus
	switch(Action[id])
	{
		case START:{
			if(!Pokemon[id]){
				if(Safari()){
					set_task(0.1,"SafariMenu",id)
					return PLUGIN_CONTINUE
				}
				switch(key)
				{
					case 0:
					{
						Pokemon[id] = BULBASAUR
						screenflash(id, 0, 255, 0, 50)
					}
					case 1:
					{
						Pokemon[id] = SQUIRTLE
						screenflash(id, 0, 0, 255, 50)
					}
					case 2:
					{
						Pokemon[id] = CHARMANDER
						screenflash(id, 255, 0, 0, 50)
					}
					case 3:
					{
						Pokemon[id] = PIKACHU
						screenflash(id, 250, 250, 10, 50)
					}
				}
				PlayersPoke[id][0] = Pokemon[id]
				PlayersXP[id][0] = 1
				set_bind(id)
				SetSpeed(id)
				ShowPokeInfo(id, Pokemon[id])
				SetAction( id )
				return PLUGIN_HANDLED
			}
		}

		case MAIN:{
			switch(key)
			{
				case 0: set_task(0.1,"ShowShopMenu",id)
				case 1: start_heal(id)
				case 2: set_task(0.1,"BillsMenu",id)
				case 3: set_task(0.1,"HelpMenu",id)
			}
		}

		case MART:{
			switch(key)
			{
				//opening/closing categories
				case 100..100+MAX_ITYPE+3:{
					new num=key-100
					if(Open[id][num]){
						Open[id][num] = false
						set_task(0.1,"ShowShopMenu",id)
					}
					else{
						Open[id][num] = true
						new parm[2];
						parm[0] = id;
						parm[1] = num;
						set_task(0.1, "ShowShopCat", 0, parm, 2);
					}
				}
				//selling items
				case 200..200+MAX_ITEMS:{
					SellItem(id, key-200)
					menu_destroy(menu)
					set_task(0.1,"ShowShopMenu",id)
					return PLUGIN_CONTINUE
				}
				//buying items, 300+ == a pokemon
				default:{
					if(BuyCheck(id)){
						if(key < MAX_ITEMS){
							buy_item(id, key)
						}
						else{
							new parm[2]
							parm[0] = id
							parm[1] = key-300
							set_task(0.1, "buy_poke",0, parm, 2)
						}
					}
				}
			}
		}

		case GO:{
			if(PlayersPoke[id][key] && key<MAX_ACTIVE_POKES){
				SwitchPoke(id, PlayersPoke[id][key], false)
			}
		}

		case RELEASE:{
			ReleasePoke(id, PlayersPoke[id][key])
		}

		case B_GIVE:{
			switch(AvailableSlot(id,PlayersPoke[id][key],-1))
			{
				case 1:{
					new tempslot = Slot(id,0,-1)
					PlayersPoke[id][tempslot] = PlayersPoke[id][key]
					PlayersXP[id][tempslot] = PlayersXP[id][key]

					PlayersPoke[id][key] = 0
					PlayersXP[id][key] = 0

					new pname[NAME_LENGTH];
					PokeToName(PlayersPoke[id][tempslot], pname);
					client_print(id, print_chat, "%s You sent %s to Bill's PC.",PREFIX, pname);

					SaveXP(id)
					menu_destroy(menu)
					set_task(0.1,"ActionMenu",id)
					return PLUGIN_HANDLED
				}
				case 0:{
					client_print(id, print_chat, "%s Sending pokemon failed.",PREFIX)
				}
				case -1:{
					client_print(id, print_chat, "%s You have too many pokemon in Bill's PC already.",PREFIX)
				}
				case -2:{
					client_print(id, print_chat, "%s You cannot have 2 of the same pokemon in Bill's PC.",PREFIX)
				}
			}
		}
		case B_TAKE:{
			switch(AvailableSlot(id,PlayersPoke[id][key]))
			{
				case 1:{
					new tempslot = Slot(id)
					PlayersPoke[id][tempslot] = PlayersPoke[id][key]
					PlayersXP[id][tempslot] = PlayersXP[id][key]

					PlayersPoke[id][key] = 0
					PlayersXP[id][key] = 0

					new pname[NAME_LENGTH];
					PokeToName(PlayersPoke[id][tempslot], pname);
					client_print(id, print_chat, "%s You retrieved %s from Bill's PC.",PREFIX, pname);

					SaveXP(id)
					menu_destroy(menu)
					set_task(0.1,"ActionMenu",id)
					return PLUGIN_HANDLED
				}
				case 0:{
					client_print(id, print_chat, "%s Retrieving pokemon failed.",PREFIX)
				}
				case -1:{
					client_print(id, print_chat, "%s You have too many pokemon out already.",PREFIX)
				}
				case -2:{
					client_print(id, print_chat, "%s You cannot take out 2 of the same pokemon.",PREFIX)
				}
			}
		}

		case GIVE_ITEM:{
			if(PlayersPoke[id][key]){
				if(ItemInfo[PlayerGive[id]] & II_LEVEL )
					LevelUpPokemon(id, key, 1, PlayerGive[id])
				else
					Check_Stone_Evolve(id, PlayersPoke[id][key], PlayerGive[id])
			}
		}

		case BILL:{
			if(NearOakCheck(id) || !is_user_alive(id)){
				switch(key)
				{
					case 0:{
						menu_destroy(menu)
						SetActionMenu( id, RELEASE )
						return PLUGIN_HANDLED
					}
					case 2:{
						SaveXP(id, 0)
						client_print(id,print_chat, "%s Your experience has been saved.",PREFIX)
					}
					case 4:{
						if(Safari()){
							menu_destroy(menu)
							set_task(0.1,"SafariMenu",id)
							return PLUGIN_CONTINUE
						}
						menu_destroy(menu)
						SetActionMenu( id, B_GIVE )
						return PLUGIN_HANDLED
					}
					case 5:{
						menu_destroy(menu)
						SetActionMenu( id, B_TAKE )
						return PLUGIN_HANDLED
					}
					case 6:{
						PlayersSet[id][SET_HUD_Y]--
						set_task(0.1,"BillsMenu",id)
					}
					case 7:{
						PlayersSet[id][SET_HUD_Y]++
						set_task(0.1,"BillsMenu",id)
					}
					case 8:{
						if(PlayersSet[id][SET_HUD_PARTY])
							PlayersSet[id][SET_HUD_PARTY]=0
						else
							PlayersSet[id][SET_HUD_PARTY]=1
						set_task(0.1,"BillsMenu",id)
					}
				}
			}
			else
				client_print(id, print_chat, "%s You need to be near Prof. Oak to use Bill's PC.", PREFIX)
		}

		case ITEM:{
			menu_destroy(menu)
			if( HasPokeItem( id , key ) )
				UseItem( id , key )
			return PLUGIN_HANDLED
		}

		case SAFARI:{
			Pokemon[id] = key

			ShowPokeInfo(id, key)
			SetAction( id )
			return PLUGIN_HANDLED
		}

		case HELP:{
			switch(key)
			{
				case 0:pokehelp(id)
				default:{
					new num[25]
					formatex(num, 25, "%d", key*10-9 )
					pokedex(id, num, true)
				}
			}
			SetAction( id )
			return PLUGIN_HANDLED
		}

		case SKILL:{
			menu_destroy(menu);
			g_isSkilled[id] = key;
			set_task(0.1, "SkillMenu", id);
			return PLUGIN_HANDLED;
		}
	}

	SetAction( id )

	if(	menu != helpmenu
	&&	menu != startmenu
	&&	menu != safarimenu)
		menu_destroy(menu);

	return PLUGIN_HANDLED;
 }

 //////////////////
 //  Start Menu  //
 //////////////////
 public StartMenu(id)
 {
	if( !is_user_connected(id) )
		return
	if( is_user_bot(id) ){
		BotPoke(id)
		return
	}

	if( Safari() ){
		SafariMenu(id)
		return
	}

	if( !g_Connected[id] )
		return
	if( PlayersPoke[id][0] || PlayersPoke[id][MAX_ACTIVE_POKES] )
		return

	if( !startmenu )
		ResetStartMenu()

	menu_display(id, startmenu, 0)
	debugMessage(id,6,"was shown Start menu");

	SetAction( id, START )
 }
 public ResetStartMenu()
 {
	startmenu = menu_create( g_coloredMenus ? "\\rChoose a Pokemon to start with:" : "Choose a Pokemon to start with:", "poke_menu_handler")
	menu_additem(startmenu, g_coloredMenus ? "\\yBulbasaur\\R\\wLeech Seed":	"Bulbasaur    Leech Seed",	"0", 0)
	menu_additem(startmenu, g_coloredMenus ? "\\ySquirtle\\R\\wBubble Beam":	"Squirtle     Bubble Beam",	"1", 0)
	menu_additem(startmenu, g_coloredMenus ? "\\yCharmander\\R\\wRage":			"Charmander   Rage",		"2", 0)
	menu_additem(startmenu, g_coloredMenus ? "\\yPikachu\\R\\wQuick Attack":	"Pikachu      Quick Attack",	"3", 0)
	menu_setprop(startmenu, MPROP_EXIT, MEXIT_NEVER)
 }

 ///////////////////
 //  Action Menu  //
 ///////////////////
 SetActionMenu(id, action)
 {
	Action[id] = action;
	ActionMenu( id );
	SetAction( id, action );
 }
 public ActionMenu(id)
 {
	if(!is_user_connected(id))
		return

	new temp[256], temp2[6], pname[NAME_LENGTH], level

	switch(Action[id])
	{
		case B_GIVE:{
			if(Safari()){
				set_task(0.1,"SafariMenu",id)
				return
			}
			copy(temp, 255, g_coloredMenus ? "\rSend to Bill:":"Send to Bill:")
		}
		case B_TAKE:{
			if(Safari()){
				set_task(0.1,"SafariMenu",id)
				return
			}
			else if( !PlayersPoke[id][MAX_ACTIVE_POKES] ){
				client_print(id, print_chat, "%s You do not have any pokemon in Bill's PC.", PREFIX);
				return
			}
			copy(temp, 255, g_coloredMenus ? "\rRetrieve from Bill:":"Retrieve from Bill:")
		}
		case RELEASE:{
			if(Safari()){
				set_task(0.1,"SafariMenu",id)
				return
			}
			copy(temp, 255, g_coloredMenus ? "\rRelease:":"Release:")
		}
		case GO:{
			if(Safari()){
				set_task(0.1,"SafariMenu",id)
				return
			}
			copy(temp, 255, g_coloredMenus ? "\rGo:":"Go:")
		}
		case GIVE_ITEM:{
			ItemToName(PlayerGive[id], pname)
			formatex(temp, 255, g_coloredMenus ? "\rGive %s To:":"Give %s To:",pname)
		}
	}
	new menu = menu_create(temp, "poke_menu_handler")
	
	RefreshPoke(id)

	new i
	if( Action[id] == B_TAKE ){
		for(i = MAX_ACTIVE_POKES; i<MAX_POKES; i++){
			if( PlayersPoke[id][i] ){
				level = PlayersLevel(id, i)
				PokeToName(PlayersPoke[id][i], pname)
				formatex(temp, 255, g_coloredMenus ? "\\w%s\\RLevel %d":"%s   Level %d",pname, level)
				formatex(temp2, 5, "%d",i)
				menu_additem(menu, temp, temp2, 0)
				debugMessage(id,6,"added item: %s",temp);
			}
		}
	}
	else {
		for(i = 0; i<MAX_ACTIVE_POKES; i++){
			if(PlayersPoke[id][i]){
				level = PlayersLevel(id, i)
				PokeToName(PlayersPoke[id][i], pname)
				formatex(temp, 255, g_coloredMenus ? "\\w%s\\RLevel %d":"%s   Level %d",pname, level)
				formatex(temp2, 5, "%d",i)
				menu_additem(menu, temp, temp2, 0)
			}
		}
	}
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)

	menu_display(id, menu, 0)
	debugMessage(id,6,"was shown an Action menu");
 }

 /////////////////
 //  Main Menu  //
 /////////////////
 public PokeMenu(parm[])
 {
	new id = parm[0]
	new center = parm[1]

	//if center = -100, we need to find a new one
	if(center==-100)
		center = NearOakCheck(id)

	//stop if not valid pokecenter or if theyre not connected
	if( center < 0 || !is_user_connected(id) )
		return

	new playermenu, playerkeys
	get_user_menu(id, playermenu, playerkeys)
	if(playermenu)
		return

	if(!Pokemon[id])
		StartMenu(id)
	else{
		if(!is_user_alive(id) || NearOakCheck(id)){

			new oak_props[MAX_OAKPROP]
			if(pev_valid(center))
				pev(center, pev_globalname, oak_props, MAX_OAKPROP-1)
			else	//lets let them be able to do everything while dead
				copy(oak_props, MAX_OAKPROP-1, "ab")

			new menu = menu_create(g_coloredMenus ? "\\rPoke Center:":"Poke Center:", "poke_menu_handler")

			if(get_ppcvar_num(pm_pokemart_open) && containi(oak_props,"a")!=-1)
				menu_additem(menu, g_coloredMenus ? "\\wPokeMart":"PokeMart", "0", 0)
			if(containi(oak_props,"b")!=-1 && is_user_alive(id))
				menu_additem(menu, g_coloredMenus ? "\\wHeal":"Heal", "1", 0)

			menu_additem(menu, g_coloredMenus ? "\\wBill's PC":"Bill's PC", "2", 0)
			menu_additem(menu, g_coloredMenus ? "\\rPokeHelp\\w":"PokeHelp", "3", 0)
			menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)

			menu_display(id, menu, 0)
			debugMessage(id,6,"was shown Main menu");

			SetAction( id, MAIN )
		}
	}
 }

 /////////////////
 //  Shop Menu  //
 /////////////////
 public ShowShopMenu(id) ShopMenu(id)
 public ShowShopCat(parm[]) ShopMenu(parm[0], parm[1])
 ShopMenu(id, icat=-1)
 {
	if(!is_user_connected(id))
		return

	if(BuyCheck(id))
	{
		new temp[256], temp2[6], cost, bool:showed_cat = false
		new i, pname[NAME_LENGTH]

		new menu = menu_create(g_coloredMenus ? "\\rPokeMart:":"PokeMart:", "poke_menu_handler")

		new cat, catsdisplay;
		if( icat < 0 || icat >= ItemCatCreated ){
			cat = 0;
			catsdisplay = ItemCatCreated;
		}
		else{
			cat = icat;
			catsdisplay = cat+1;
		}

		while( cat < catsdisplay )
		{
			formatex(temp, 255, g_coloredMenus ? "\\r%s\\R(%s)":"-%s(%s)", ItemCatName[cat], Open[id][cat]?"-":"+")
			formatex(pname, NAME_LENGTH-1, "%i", cat+100);
			menu_additem(menu, temp, pname, 0)

			if(Open[id][cat]){
				showed_cat = true;
				for(i = 0; i < ItemsCreated; i++){
					if( !(ItemInfo[i] & II_SPECIAL)
					&& ItemCat[i] == cat ){
						cost = CostOfItem(i, true)
						if(cost){
							ItemToName(i, pname)
							formatex(temp2, 5, "%d", i)
							if(cost<0){
								if(!is_user_admin(id))
									continue
								formatex(temp, 255, g_coloredMenus ? "\\y%s\\R%d":"-%s   %d",pname, abs(cost))
							}
							else
								formatex(temp, 255, g_coloredMenus ? "\\w%s\\R%d":"%s   %d",pname, abs(cost))
							menu_additem(menu, temp, temp2, 0)
						}
					}
				}
			}
			cat++;
		}
		if( !showed_cat ){
			if(PokeItem(id)){
				formatex(temp, 255, g_coloredMenus ? "\\ySell Your Items\\R(%s)":"---Sell Your Items (%s)", Open[id][MAX_ITYPE+1]?"-":"+")
				formatex(pname, NAME_LENGTH-1, "%i", 100+MAX_ITYPE+1)
				menu_additem(menu, temp, pname, 0)

				if(Open[id][MAX_ITYPE+1]){
					for(i = 0; i < ItemsCreated; i++){
						if(HasPokeItem(id, i)){
							cost = floatround(CostOfItem(i, true)*SELLFACTOR)
							if(cost){
								ItemToName(i, pname)
								formatex(temp2, 5, "%d", i+200)
								if(cost<0){
									if(!is_user_admin(id))
										continue
									formatex(temp, 255, g_coloredMenus ? "\\y%s\\R%d":"-%s   %d",pname, abs(cost))
								}
								else
									formatex(temp, 255, g_coloredMenus ? "\\w%s\\R%d":"%s   %d",pname, abs(cost))
								menu_additem(menu, temp, temp2, 0)
							}
						}
					}
				}
			}

			formatex(temp, 255, g_coloredMenus ? "\\rPokemon\\R(%s)":"-Pokemon(%s)", Open[id][MAX_ITYPE+2]?"-":"+")
			formatex(pname, NAME_LENGTH-1, "%i", 100+MAX_ITYPE+2)
			menu_additem(menu, temp, pname, 0)
			if(Open[id][MAX_ITYPE+2]){
				for(i=1; i <= TOTAL_POKES; i++){
					if(!NonBindPoke(i) && !BindPoke(i))
						continue
					cost = CostOfPoke(i)
					if(cost){
						PokeToName(i, pname)
						formatex(temp2, 5, "%d", i+300)
						if(cost<0){
							if(!is_user_admin(id))
								continue
							formatex(temp, 255, g_coloredMenus ? "\\y%s\\R%d":"-%s   %d",pname, abs(cost))
						}
						else
							formatex(temp, 255, g_coloredMenus ? "\\w%s\\R%d":"%s   %d",pname, abs(cost))
						menu_additem(menu, temp, temp2, 0)
					}
				}
			}
		}

		menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)

		menu_display(id, menu, 0)
		debugMessage(id,6,"was shown PokeMart menu");

		SetAction( id, MART )
	}
 }

 //////////////////
 //  Bills Menu  //
 //////////////////
 public BillsMenu(id)
 {
	if(!is_user_connected(id))
		return

	new menu = menu_create(g_coloredMenus ? "\\rBill's PC:":"Bill's PC:", "poke_menu_handler")
	if(!Safari())
		menu_additem(menu, g_coloredMenus ? "\\wRelease Pokemon":"Release Pokemon", "0", 0)
	if(SaveXPon()){
		menu_additem(menu, g_coloredMenus ? "\\wSave Data":"Save Data", "2", 0)
	}
	if(Safari())
		menu_additem(menu, g_coloredMenus ? "\\wChange Pokemon":"Change Pokemon", "4", 0)
	else{
		menu_additem(menu, g_coloredMenus ? "\\wSend Pokemon":"Send Pokemon", "4", 0)
		menu_additem(menu, g_coloredMenus ? "\\wRetrieve Pokemon":"Retrieve Pokemon", "5", 0)
	}
	menu_additem(menu, g_coloredMenus ? "\\wMove HUD Up":"Move HUD Up", "6", 0)
	menu_additem(menu, g_coloredMenus ? "\\wMove HUD Down":"Move HUD Down", "7", 0)
	if(!Safari()){
		if(PlayersSet[id][SET_HUD_PARTY])
			menu_additem(menu, g_coloredMenus ? "\\wHide Active Party":"Hide Active Party", "8", 0)
		else
			menu_additem(menu, g_coloredMenus ? "\\wShow Active Party":"Show Active Party", "8", 0)
	}

	menu_display(id, menu, 0)
	debugMessage(id,6,"was shown Bills menu");

	SetAction( id, BILL )
 }

 /////////////////////
 //  Item Use Menu  //
 /////////////////////
 public ItemUseMenu(id)
 {
	if(!is_user_connected(id))
		return

	if(is_user_alive(id))
	{
		if(PokeItem(id))
		{
			new menu = menu_create(g_coloredMenus ? "\\rYour Items:":"Your Items:", "poke_menu_handler")
			new temp[256], temp2[6], iname[NAME_LENGTH], num, status[25]
			new bool:shown = false

			for( num = 0; num < ItemsCreated; num++)
			{
				if(HasPokeItem(id,num)){

					shown = false
					ItemToName(num,iname)
					formatex(temp2, 5, "%d",num)

					if( ItemInfo[num] & II_BIKE ){
						if(g_Status[id][STATUS_BIKE])
							copy(status, 24, "Riding")
						else
							copy(status, 24, "Walking")
						formatex(temp, 255, g_coloredMenus ? "\\w%s (%s)":"%s (%s)",iname, status)
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( ItemInfo[num] & II_PDAMAGE ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (Additional Pokedamage:%d)":"%s (Additional Pokedamage:%d)",iname, Item[id][num]*ItemPDamage[num])
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( ItemInfo[num] & II_SPEED ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (Additional Speed:%d)":"%s (Additional Speed:%d)",iname, Item[id][num]*ItemSpeed[num])
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( ItemInfo[num] & II_MAXHP ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (Additional HP:%d)":"%s (Additional HP:%d)",iname, Item[id][num]*ItemMaxHP[num])
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( ItemInfo[num] & II_ARMOR ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (Additional Armor:%d)":"%s (Additional Armor:%d)",iname, Item[id][num]*ItemArmor[num])
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( ItemInfo[num] & II_DAMAGE ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (Additional Damage:%d)":"%s (Additional Damage:%d)",iname, Item[id][num]*ItemDamage[num])
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( ItemInfo[num] & II_CATCH ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (Catch Chance: %d%%)(%d)":"%s (Catch Chance: %d%%)(%d)",iname, ItemCatch[num], Item[id][num] )
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( ItemInfo[num] & II_HEAL && ItemHeal[num] != -1 ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (Heals %d)(%d)":"%s (Heals %d)(%d)",iname, ItemHeal[num], Item[id][num] )
						menu_additem(menu, temp, temp2, 0)
						shown = true
					}
					if( !shown ){
						formatex(temp, 255, g_coloredMenus ? "\\w%s (%d)":"%s (%d)",iname, Item[id][num])
						menu_additem(menu, temp, temp2, 0)
					}
				}
			}
			menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)

			menu_display(id, menu, 0)
			debugMessage(id,6,"was shown Item menu");

			SetAction( id, ITEM )
		}
		else
			ShopMenu(id)
	}
 }

 /////////////////
 //  Help Menu  //
 /////////////////
 public HelpMenu(id)
 {
	if( !is_user_connected(id) )
		return;

	if( Action[id] == HELP )
		return;

	if( !helpmenu )
		ResetHelpMenu();

	menu_display(id, helpmenu, 0);
	debugMessage(id,6,"was shown Help menu");

	SetAction( id, HELP );
 }
 public ResetHelpMenu()
 {
	helpmenu = menu_create(g_coloredMenus ? "\\rPokeHelp:":"PokeHelp:", "poke_menu_handler")
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokeMod Basics":"PokeMod Basics", "0", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (1-10)":"Pokedex (1-10)", "1", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (11-20)":"Pokedex (11-20)", "2", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (21-30)":"Pokedex (21-30)", "3", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (31-40)":"Pokedex (31-40)", "4", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (41-50)":"Pokedex (41-50)", "5", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (51-60)":"Pokedex (51-60)", "6", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (61-70)":"Pokedex (61-70)", "7", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (71-80)":"Pokedex (71-80)", "8", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (81-90)":"Pokedex (81-90)", "9", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (91-100)":"Pokedex (91-100)", "10", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (101-110)":"Pokedex (101-110)", "11", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (111-120)":"Pokedex (111-120)", "12", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (121-130)":"Pokedex (121-130)", "13", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (131-140)":"Pokedex (131-140)", "14", 0)
	menu_additem(helpmenu, g_coloredMenus ? "\\wPokedex (141-150)":"Pokedex (141-150)", "15", 0)

	menu_setprop(helpmenu, MPROP_EXIT, MEXIT_ALL)
 }

 //////////////////
 //  Skill Menu  //
 //////////////////
 public SkillMenu(id)
 {
	if( !is_user_connected(id) )
		return;

	new menu = menu_create(g_coloredMenus ? "\\rSkills learned:":"Skills learned:", "poke_menu_handler");

	new PokeFile[128];
	Poke_FileName( F_Pokedex, PokeFile);
	new pokedexline[256], charnum;

	new skills[MAX_SKILLS+1], skillnames[MAX_SKILLS+1][NAME_LENGTH], skill_count = 1;

	new i, pid = Pokemon[id];
	for( i = -1; i<MAX_ACTIVE_POKES; i++ ){
		if( i != -1 ){
			pid = PlayersPoke[id][i];

			//if weve already added the skill in, we don't need to add it again
			if( pid == Pokemon[id] )
				continue;
		}
		while( pid && skill_count < MAX_SKILLS+1 ){
			if( BindPoke(pid) && ( i==-1 || GlobalPoke(pid) ) ){
				//read then seperate the skill name
				read_file(PokeFile,pid+POKEDEX_OFFSET,pokedexline,255,charnum);
				strbreak(pokedexline,skillnames[skill_count],NAME_LENGTH-1,pokedexline,1);

				if(pid == g_isSkilled[id])
					format(skillnames[skill_count], NAME_LENGTH-1, g_coloredMenus ? "\\y%s":"-%s",skillnames[skill_count]);

				skills[skill_count] = pid;
				skill_count++;
			}

			pid = AnyEvolveTo(pid);
		}
	}

	for( i=1; i < MAX_SKILLS+1; i++){
		if(skillnames[i][0]){
			formatex(pokedexline, 11, "%d", skills[i]);
			menu_additem(menu, skillnames[i], pokedexline, 0);
		}
		else
			break;
	}
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL);

	menu_display(id, menu, 0);
	debugMessage(id,6,"was shown Skill menu");

	SetAction( id, SKILL );
 }

 ///////////////////
 //  Safari Menu  //
 ///////////////////
 public SafariMenu(id)
 {
	if( !is_user_connected(id) )
		return;

	if( Action[id] == SAFARI )
		return;

	if( !safarimenu )
		ResetSafariMenu();

	menu_display(id, safarimenu, 0);
	debugMessage(id,6,"was shown Safari menu");

	SetAction( id, SAFARI );
 }
 public ResetSafariMenu()
 {
	safarimenu = menu_create(g_coloredMenus ? "\\rPokemon:":"Pokemon:", "poke_menu_handler")
	new pname[NAME_LENGTH], temp[65], temp2[10], level
	for(new i=1; i<=TOTAL_POKES; i++){
		level = SafariLevel(i)
		if(level){
			PokeToName(i, pname)
			formatex(temp, 64, g_coloredMenus ? "\\w%s\\RLevel %d":"%s   Level %d",pname,level)
			formatex(temp2, 64, "%d",i)
			menu_additem(safarimenu, temp, temp2, 0)
		}
	}

	menu_setprop(safarimenu, MPROP_EXIT, MEXIT_ALL)
 }


 
 
 