
// Please only edit if you know what you are doing
//    * Note the default values, if there is a decimal '.' in the value, 
//		there must be a decimal in your value
//			Examples:
//				LEECH_SEED can be 5, 10, 20, etc.
//				LEECH_SEED can NOT be 5.0, 10.5, 20.0, etc.
//				LEECH_SEED_TIME can be 5.0, 10.5, 20.0, etc.
//				LEECH_SEED_TIME can NOT be 5, 10, 20, etc.


#define DELAY_LEVEL_REDUCE			0.05	//how much time is taken away per level

#define LEECH_SEED					5		//how much damage and health is returned
#define LEECH_SEED_TIME				5.0		//how often (in seconds) leech seed occurs
#define GROWTH_REDUCE				0.5		//percent of total delay time to use if they have growth (0.75 for 20 seconds would end up being 15 seconds) *note this has to be less than 1.0

#define VINE_WHIP_JUMP				300.0	//how high vine whip pushes you into the sky
#define VINE_WHIP_DAMAGE			25		//how much damage it does

#define ROCK_THROW_VEC				2000	//how hard rock throw and fire blast will go

#define THUNDERBOLT_DISTANCE		1000	//how close players have to be to get electricuted

#define SQUIRTLE_BUBBLES			20		//how many bubbles does squirtle start with
#define WARTORTLE_BUBBLE_NUM_MULT	2		//multiplies SQUIRTLE_BUBBLES by this for wartortles bubbles
#define BLASTOISE_BUBBLE_NUM_MULT	4		//multiplies SQUIRTLE_BUBBLES by this for blastoises bubbles
#define SQUIRTLE_BUB_DAMAGE			30		//damage bubble beam does
#define WARTORTLE_BUBBLE_DAM_MULT	0.2		//multiplies SQUIRTLE_BUB_DAMAGE by this for wartortles bubbles damage (don't forget that this shoots 10x as fast)
#define BLASTOISE_BUBBLE_DAM_MULT	0.15	//multiplies SQUIRTLE_BUB_DAMAGE by this for blastoises bubbles damage (don't forget that this shoots 10x as fast, and there are 2 beams)

#define CONFUSION_DISTANCE			200		//how close players have to be to be confused

#define VOLTORB_RADIUS				500		//radius of voltorb's explosion
#define VOLTORB_DAMAGE				150		//max damage of voltorb's explosion

#define ONIX_THROW					2000	//speed at which onix throws a boulder, anything above 2000 gets screwed up
#define ROCK_DAMAGE					100		//max damage that boulders can do

#define GOLEM_ROCK_LEVEL 			19		//every # of levels, one more boulder will fall

#define ABRA_TELEPORT_TIME			2.0		//seconds to wait before teleporting

#define PSYBEAM_SPEED				500		//how fast a psybeam moves
#define PSYBEAM_DAMAGE				150		//max damage psybeam can do

#define POISON_POWDERS				5		//how many poison powders are created
#define POWDER_TIME					10		//how long a powder lasts
#define POWDER_RANGE				100		//how far does powder affect people?

#define HAUNTER_MAX_DISTANCE 		1000	//max distance someone can be to be affected by haunter's sleep
#define DREAM_EAT_DAMAGE 			33		//how much damage does dream eat do?

#define MEOWTH_BONUS 				1.5		//this is multiplied to the damage if they have meowth/persian active

#define RAGE_FACTOR					5		//every # damage, rage will go up by 1
#define MAX_RAGE					30		//max rage you can have
#define COUNTER_FACTOR				3		//damage = rage / #

#define BIDE_FACTOR					5		//every # damage, bide damage will go up by 1

#define RAZOR_LEAF_FACTOR			2		//this will be multiplied by the players level for razor leaf damage

#define DEFENSE_CURL				3		//armor given = damage / #

#define FLASH_TIME					1.0		//how long a user is flashed

#define REFLECT_ACTIVE				50		//additional chance that reflect will work if they have the pokemon active

#define STRING_SHOT_TIME 			10.0	//how long string shot slows a user

#define LEECHLIFE 					1		//how much damage does leechlife damage and heal for
#define BITE 						2		//how much damage does Bite damage and heal for

#define HYPER_FANG					4		//knife attacks will do (maxhp of player) / #
#define SUPER_FANG					2		//""	""		""		""		""		""

#define FLY							200		//boost given every keydown
#define FLY_FLAP					1		//do players have to press keydown repeatedly (1=yes, 0=no)

#define REST 						1		//HP given every .1 seconds

#define SUBSTITUTE 					4		//HP has to be below maxhp/# in order to substitute

#define GUST_FACTOR 				2		//level / # = damage
#define GUST_VELOCITY 				20		//gust damage * # = final velocity of gust

#define SLAP 						5		//level * # = slap initial (before factoring in which skill)
#define DOUBLE_SLAP 				50		//slap initial / # = damage
#define BODY_SLAM 					45		//""	""		""		""
#define SKULLBASH 					40		//""	""		""		""

#define SURF_DISTANCE				100		//how close players are effected by a surf wave
#define SURF_DUCK					1		//players ducking are not affected by surf waves (1=not affected; 0=affected)

#define SKY_ATTACK_DAMAGE			2		//level * # = max damage
#define SKY_ATTACK_RADIUS			200		//level + # = radius of max damage

#define QUICK_ATTACK				50		//amount of boost quick attack gives

#define BLIZZARD_TIME				5.0		//initial time of blizzard
#define BLIZZARD_RADIUS				10		//level * # = max radius of blizzard

#define LIMIT_BARRIER				0		//max amount of barriers that can be placed near each other (0-no limit)
#define BARRIER_MIN_HP				10		//min amount of hp a barrier will have
#define BARRIER_MAX_HP				100		//max amount of hp a barrier will have

#define THUNDER_WAVE_TIME			5.0		//how long thunder wave paralyzes for

#define MAX_INVIS					200		//max visibility of someone with nightshade (should be higher than MIN_INVIS and range from 1-255)
#define MIN_INVIS					0		//min visibility of someone with nightshade (should be lower than MAX_INVIS and range from 0-254)

									//don't forget this can be used 5 times
#define PSYCHIC_DAMAGE				10		//max damage psychic can do
#define PSYCHIC_RANGE				500		//starting range of psychic
#define PSYCHIC_DELAY				2.0		//skill delay forced on players

#define CONVERSION_ALPHA			10		//how invisible are players that are using conversion (0=completely invisible 255=completely visible)
#define CONVERSION_TIME				10		//this + 5 = max time someone can use conversion

#define STRENGTH_DIST				150		//how close to an object someone has to be/how far an object will be moved from the player
#define STRENGTH_DAMAGE				2		//damage done to players being grabbed every tenth of a second (2 = 20 damage every second)

//Want to be able to edit something else? Ask on the PokeMod Forums!