
 ///////////////////////////////////////
 //  When someone presses +pokeskill  //
 ///////////////////////////////////////
 public pokeskill_down(id)
 {
	g_StopSkill[id] = false;
	if(!PMon()){
		client_print(id,print_chat, "%s PokeMod is currently disabled.",PREFIX)
		return PLUGIN_HANDLED
	}
	else if(PM_disabled == -1){
		client_print(id,print_chat, "%s PokeMod has disabled the use of all pokemon skills for the map.",PREFIX)
		return PLUGIN_HANDLED
	}
	else if(PlayersPoke[id][0]==0){
		StartMenu(id)
		return PLUGIN_HANDLED
	}

	new Float:current_time = get_gametime();
	if(current_time-g_lastSkill[id] < SKILL_SPAM){
		client_print(id, print_chat, "%s Stop trying to spam PokeMod skills.",PREFIX);
		return PLUGIN_HANDLED;
	}
	g_lastSkill[id] = current_time;

	if(g_isItemed[id]){
		SetActionMenu( id, GO );
		return PLUGIN_HANDLED;
	}

	if(!is_user_alive(id)){
		new parm[2];
		parm[0] = id;
		parm[1] = 0;
		set_task(0.1, "PokeMenu", 0, parm, 2);
		return PLUGIN_HANDLED;
	}

	new skill_num, command[32];
	read_argv(0,command,31);
	replace(command, 31, "+pokeskill", EMPTY);
	skill_num = str_to_num(command);

	new poke_skills[MAX_SKILLS+1], skill_count = 1;
	new pid = Pokemon[id];
	for( new i = -1; i<MAX_ACTIVE_POKES; i++ ){
		if( i != -1 ){
			pid = PlayersPoke[id][i];

			//if weve already added the skill in, we don't need to add it again
			if( pid == Pokemon[id] )
				continue;
		}
		while( pid && skill_count < MAX_SKILLS+1 ){
			if( BindPoke(pid) && ( i==-1 || GlobalPoke(pid) ) ){
				poke_skills[skill_count] = pid;
				skill_count++;
			}

			pid = AnyEvolveTo(pid);
		}
	}

	if(skill_count > 2 && !skill_num ){	//greater than 2 because it is set to 2 if there is only one skill
		if( !g_isSkilled[id] ){
			SkillMenu(id);
			return PLUGIN_HANDLED;
		}
		else
			pid = g_isSkilled[id];
	}
	else if( skill_num )
		g_isSkilled[id] = pid = poke_skills[skill_num];
	else
		g_isSkilled[id] = pid = poke_skills[1];

	if( !pid )
		g_isSkilled[id] = pid = Pokemon[id];

	if( DisAllowSkill( id, true, pid, false ) )
		return PLUGIN_HANDLED;

	new parm[2];
	parm[0] = id;
	parm[1] = pid;
	do_skill(parm);

	new pname[NAME_LENGTH]
	PokeToName(pid, pname)
	debugMessage(id,6,"keyed down with %s",pname)

	return PLUGIN_HANDLED;
 }

 ////////////////////////////////////////
 //  When someone releases +pokeskill  //
 ////////////////////////////////////////
 public pokeskill_up(id)
 {
	new pname[NAME_LENGTH]
	PokeToName(g_isSkilled[id], pname)
	debugMessage(id,6,"keyed up with %s",pname)

	switch( g_isSkilled[id] )
	{
		case NIDOKING:{
			if(is_user_alive(PlayerEnt[id]))
				poke_UnStuck(PlayerEnt[id], false);
			PlayerEnt[id] = 0;
		}
		case PORYGON:{
			if( is_user_alive(id) )
				fm_set_rendering(id);
		}
	}

	if( g_isSkilled[id] ){
		if( Action[id] == SKILL )
			SkillMenu(id);
		else
			g_isSkilled[id] = 0;
	}

	g_StopSkill[id] = true;

	#if SKILL_UNSPAM == 1
	g_lastSkill[id] = 0.0;
	#endif

	return PLUGIN_HANDLED;
 }
 
 skill_handler(attacker, attacker_poke=0, victim=0, victim_poke=0, weapon=0, damage=0, bool:repeat_skill=true)
 {
	new at_pname[NAME_LENGTH], vi_pname[NAME_LENGTH];
	PokeToName(attacker_poke, at_pname);
	PokeToName(victim_poke, vi_pname);
	debugMessage(0,8,"Handling Skill: attacker(%s) victim(%s) weapon(%d) damage(%d) repeater(%d)",
	at_pname, vi_pname, weapon, damage, repeat_skill);

	if(attacker_poke && PokeASkillForward > -1)
	{
		new functionReturn
		ExecuteForward(PokeASkillForward, functionReturn, attacker, attacker_poke, victim, weapon, damage)

		// Forward will return the highest value, don't return 1 or 2 in function cause of return handled or handled_main
		// and 0 is used by continue and invalid return.
		if(functionReturn==PLUGIN_HANDLED)	//if something was handled, let's 'pretend' that they don't have that pokemon anymore
		{
			attacker_poke = 0
		}
	}
	if(victim_poke && PokeVSkillForward > -1)
	{
		new functionReturn
		ExecuteForward(PokeVSkillForward, functionReturn, attacker, victim, victim_poke, weapon, damage)

		// Forward will return the highest value, don't return 1 or 2 in function cause of return handled or handled_main
		// and 0 is used by continue and invalid return.
		if(functionReturn==PLUGIN_HANDLED)	//if something was handled, let's 'pretend' that they don't have that pokemon anymore
		{
			victim_poke = 0
		}
	}

	//if someone wasn't hurt, then it's just a repeating skill
	if( repeat_skill ){
		if( !DisAllowSkill(attacker, false, attacker_poke) ){
			switch(attacker_poke)
			{
				case KOFFING..WEEZING,GRIMER..MUK:{
					Gas(attacker)
				}
				case GASTLY..GENGAR:{
					NightShade(attacker)
				}
			}
		}
	}

	//skills where the victim has to be alive
	//mainly things that effect only the victim
	if(is_user_alive(victim) && !DisAllowSkill(victim, false, victim_poke)){
		switch(victim_poke)
		{
			case CHARMANDER:
				Take_Rage(victim, attacker, damage)
			case GEODUDE:
				Defense_Curl(victim, damage)
		}
	}

	//no skills past here will do anything if it's the same person
	if(attacker==victim)
		return

	//skills where the attacker has to be alive
	//mainly things that effect only the attacker
	if ( is_user_alive(attacker) && !DisAllowSkill(attacker, false, attacker_poke) ) {

		switch(attacker_poke)
		{
			case DODUO:
				Double_Edge(attacker, victim, weapon)
			case DODRIO:
				Tri_Attack(attacker, weapon)
		}
	}

	//skills where the attacker && victim has to be alive
	//mainly things that effect both, such as extra damage
	if ( is_user_alive(victim) && is_user_alive(attacker) && !DisAllowSkill(attacker, false, attacker_poke) ) {

		switch(attacker_poke)
		{
			case TANGELA:
				Absorb(attacker, victim)
			case CHARMANDER:
				Do_Rage(attacker, victim)
			case ELECTABUZZ:
				Flash(attacker, victim, damage)
			case PERSIAN:
				Scratch(victim, weapon)
			case CATERPIE:
				String_Shot(attacker, victim)
			case PINSIR:
				Guillotine(attacker, victim, weapon, damage)
			case RATTATA:
				Hyper_Fang(victim, attacker, damage, weapon)
			case DRAGONAIR:
				Dragon_Rage(victim, attacker, damage)
			case MEWTWO:
				Psywave(victim, attacker, damage)
			case WEEPINBELL:
				Acid(attacker, victim)
		}
	}
	//need to keep making sure theyre alive incase they died by a pokeskill
	if( is_user_alive(victim) && is_user_alive(attacker) && !DisAllowSkill(victim, false, victim_poke) ){

		switch(victim_poke)
		{
			case CHARMELEON:
				Counter(victim, attacker)
			case DRATINI:
				Thunder_Wave(victim, attacker)
			case EKANS:
				Wrap(attacker, victim)
			case ALAKAZAM:
				Reflect(victim, weapon, damage)
		}
	}
 }
 bool:SkillDisabled( pokemon )
 {
	if( PokeInfo[pokemon]&PI_DISABLE || DisabledPoke(pokemon) )
		return true;
	return false;
 }
 bool:DisAllowSkill(id, bool:bind, pokemon, bool:stop_skilled=false)
 {
	if( PM_disabled == -1 ){
		if(bind) client_print(id,print_chat, "%s PokeMod has disabled the use of skills.",PREFIX);
		return true;
	}
	//only if theyre alive, dont have a bind time, or waiting
	else if( BindUsed[id] == WAIT_TIME ){
		if(stop_skilled)	g_StopSkill[id] = true;
		return true;
	}
	else if( BindUsed[id] > 0.0 ){
		if(stop_skilled)	g_StopSkill[id] = true;
		if(bind)			sounddeny(id);
		return true;
	}
	else if( g_Status[id][STATUS_ASLEEP] ){
		if(stop_skilled)	g_StopSkill[id] = true;
		if(bind)			client_print(id,print_chat, "%s You cannot use skills while you are asleep.",PREFIX);
		return true;
	}
	else if( DisabledPoke(pokemon) ){
		if(stop_skilled)	g_StopSkill[id] = true;
		if(bind)			client_print(id,print_chat, "%s This pokemon/skill has been disabled.",PREFIX);
		return true;
	}
	#if MOD==CS
	else if( cs_get_user_vip(id) ){
		if(stop_skilled)	g_StopSkill[id] = true;
		if(bind)			client_print(id, print_chat, "%s VIPs are not allowed to use pokemon skills.",PREFIX);
		return true;
	}
	#endif
	#if MOD==NS
	else if( ns_get_class(id) == CLASS_COMMANDER ){
		if(stop_skilled)	g_StopSkill[id] = true;
		if(bind)			client_print(id, print_chat, "%s Commanders are not allowed to use pokemon skills.",PREFIX);
		return true;
	}
	#endif
	return false;
 }
 
 //////////////////////////
 //  Do a pokemon skill  //
 //////////////////////////
 public do_skill(parm[])
 {
	new id = parm[0]
	new pid = parm[1]
	new pname[NAME_LENGTH]
	PokeToName(pid, pname)

	if( !is_user_alive(id) || DisAllowSkill( id, true, pid, (Action[id]!=SKILL) ) || g_StopSkill[id] ){
		g_StopSkill[id] = false;
		return;
	}
	else {
		if(pid && PokeBSkillForward > -1)
		{
			new functionReturn
			ExecuteForward(PokeBSkillForward, functionReturn, id, pid)

			// Forward will return the highest value, don't return 1 or 2 in function cause of return handled or handled_main
			// and 0 is used by continue and invalid return.
			if(functionReturn==PLUGIN_HANDLED)	//if something was handled, stop
			{
				return
			}
		}

		switch(pid){
			//Grass
			case BULBASAUR,IVYSAUR:
										Leech_Seed(id)
			case VENUSAUR:
										Solar_Beam(id)
			case BELLSPROUT,WEEPINBELL:
										Vine_Whip(id)
			case VICTREEBEL:
										Razor_Leaf(id)
			//Fire
			case CHARIZARD:
										Fire_Blast(id)
			case GROWLITHE:
										Roar(id)
			case ARCANINE:
										Flamethrower(id)
			case MAGMAR:
										Smoke_Screen(id)
			//Water
			case SLOWPOKE,SLOWBRO:
										Confusion(id)
			case MAGIKARP:
										Splash(id)
			case GYARADOS:
										Surf(id)
			case SQUIRTLE,WARTORTLE,BLASTOISE:
										Bubble_Beam(id)
			case STARYU,STARMIE:
										Recover(id)
			//Electric
			case PIKACHU:
										Quick_Attack(id)
			case RAICHU:
										Thunderbolt(id)
			case VOLTORB:
										pokedamage(id, id, 1000*Health(id), "Self-Destruct")
			case ELECTRODE:
										pokedamage(id, id, 1000*Health(id), "Explosion")

			//Rock
			case GRAVELER,METAPOD:
										Harden(id)
			case GOLEM:
										Rock_Slide(id)
			case ONIX:
										Rock_Throw(id)

			//Psychic
			case ABRA:
										Teleport(id)
			case KADABRA:
										Psybeam(id)
			case MRMIME:
										Barrier(id)
			case JYNX:
										Blizzard(id)
			case MEW:
										Psychic(id)
			//Bug
			case VENONAT,VENOMOTH:
										Poison_Powder(id)
			case SCYTHER:
										Double_Team(id)
			case BUTTERFREE:
										Substitute(id)
			//Poison
			case ARBOK:
										Glare(id)
			case NIDOKING:
										Strength(id)

			//Ghost
			case HAUNTER,GENGAR:
										Hypnosis(id)
			//Normal
			case SNORLAX:
										Rest(id)
			case PIDGEY,PIDGEOTTO:
										Gust(id)
			case PIDGEOT:
										Fly(id)
			case CHANSEY:
										Egg_Bomb(id)
			case PORYGON:
										Conversion(id)

			//Flying
			case ARTICUNO:
										Mist(id)
			case ZAPDOS:
										Thunder(id)
			case MOLTRES:
										Sky_Attack(id)
			case DRAGONITE:
										Hyper_Beam(id)

			default:{
										client_print(id, print_chat, "%s %s is not a bind pokemon.",PREFIX,pname)
										sounddeny(id)
										return
			}
		}
	}
	debugMessage(id,6,"used %s",pname)

	if(g_isSkilled[id]){
		set_task(0.1,"do_skill", POKESKILL_TASK+id, parm,2)
	}
 } 

 /////////////////////////
 //  Resets all skills  //
 /////////////////////////
 ResetSkills(id, bool:Round_Skills)
 {
	debugMessage(id,4,"reset skills");

	//things to be reset only after death/round end
	if(Round_Skills){
		new bubnum = SQUIRTLE_BUBBLES;
		if(HasPokemon(id,WARTORTLE)!=-1)
			bubnum *= WARTORTLE_BUBBLE_NUM_MULT;
		else if(HasPokemon(id,BLASTOISE)!=-1)
			bubnum *= BLASTOISE_BUBBLE_NUM_MULT;
		bubbles[id] = bubnum;
	}
	else{	//things not to be set after death/round end
		if(g_Charge[id] && !ChargePoke(Pokemon[id])){
			if(RepPoke(Pokemon[id]))
				bind_used(id, Pokemon[id]);
			else{
				new subpoke = AnyEvolveTo(Pokemon[id]);
				while(subpoke && subpoke!=Pokemon[id]){
					if(RepPoke(subpoke)){
						bind_used(id, subpoke);
						break;
					}
					subpoke = AnyEvolveTo(subpoke);
				}
			}
		}
	}

	g_isSkilled[id] = 0;

	rage[id] = 0;
	fm_set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255);
	clear_leechs(id);
	screenflash(id,0,0,0,0);
	EggBomb[id] = 0;
	if(pev_valid(PlayerEnt[id])){
		new szClass[32];
		pev(PlayerEnt[id], pev_classname, szClass, 31);
		if(equali(szClass, "psy_beam"))
			psybeam_touch(PlayerEnt[id], 0);
	}
	PlayerEnt[id] = 0;
	g_Charge[id] = 0;

	SetSpeed(id);
 }
 
 /////////////////////////////
 //  Organized bind delays  //
 /////////////////////////////
 bind_used(id, pid, Float:over_ride=WAIT_TIME)
 {
	new Float:tasktime, Float:oldtime

	tasktime = PokeDelay[pid]

	oldtime = tasktime	//this makes it so there is in fact a limit on skill times
	if(oldtime<=3.0)
		oldtime = 3.0

	tasktime -= (PlayersLevel(id, PlayersActive[id])*DELAY_LEVEL_REDUCE)

	if(HasPokemon(id, VENUSAUR)!=-1)
		Growth(id, tasktime, VENUSAUR)
	else if(HasPokemon(id, IVYSAUR)!=-1 )
		Growth(id, tasktime, IVYSAUR)

	if(tasktime < oldtime/3)
		tasktime = oldtime/3

	remove_task(id+BIND_TASK)
	BindUsed[id] += tasktime

	if( over_ride != WAIT_TIME || pid == 0 )
		BindUsed[id] += over_ride

	if(BindUsed[id]>0.0)
		set_task(0.1, "bind_minus",id+BIND_TASK,EMPTY,0,"a",floatround(BindUsed[id]*10)+1)
 }
 
 /////////////////////////////////////////////////
 //  If we want to set it to exactly something  //
 /////////////////////////////////////////////////
 set_bind(id, Float:time=0.0)
 {
	BindUsed[id] = time

	remove_task(id+BIND_TASK)

	if(BindUsed[id]>0.0)
		set_task(0.1, "bind_minus",id+BIND_TASK,EMPTY,0,"a",floatround(BindUsed[id]*10)+1)
 }
 
 ///////////////////////////////////////////////////////////////////
 //  If I need to stop them after they've used it a couple times  //
 ///////////////////////////////////////////////////////////////////
 end_rep_use(id, pokemon, Float:max)
 {
	g_Charge[id]++

	if(g_Charge[id] >= max*10){
		bind_used(id, pokemon)
		g_Charge[id] = 0
	}
 }
 public bind_minus(id)
 {
	id -= BIND_TASK;
	BindUsed[id] -= 0.1;
	if(BindUsed[id]<0.1){
		set_bind(id);
	}
 }
 end_delay(id, poke)
 {
	set_bind(id);
	bind_used(id, poke);
 }
 
 //////////////////////////////////////////////////////
 //  The pokemon skills that require pressing a key  //
 //   (this is also seperated into pokemon types)    //
 //////////////////////////////////////////////////////
 ///////////////////
 // Grass Pokemon //
 ///////////////////
 Solar_Beam(id)
 {
	new Attack[]= "Solar Beam"
	if(is_user_outside(id)){
		new level = PlayersLevel(id, PlayersActive[id])
		new origin[3], aimvec[3], Float:f_origin[3], Float:f_aimvec[3]

		get_user_origin(id, origin)
		get_user_origin(id, aimvec, 2)
		IVecFVec(origin, f_origin)
		IVecFVec(aimvec, f_aimvec)

		Linedamage(id, f_origin, f_aimvec, level/2, level, Attack)
		MakeLine(0,origin,aimvec,zbeam6,1,1,1,level,0,255,255,255,255,0)
		emit_sound(id,CHAN_VOICE, SOUNDS[SND_SUCK], 1.0, ATTN_NORM, 0, PITCH_NORM)

		end_rep_use(id, VENUSAUR, 1.0)
	}
	else{
		client_print(id, print_center, "You need to be outside to use %s", Attack)
	}
 }
 Leech_Seed(id)
 {
	new abody, aid, parm[2]
	parm[0] = id
	get_user_aiming(id, aid, abody)

	if( is_user_alive(aid) && (Team(id)!=Team(aid) || FFon()) ){
		g_isLeeched[id][aid] = true
		parm[1] = aid
		set_task(0.1, "leech_seed_loop",0, parm, 2)
		bind_used(id,BULBASAUR)
	}
 }
 public leech_seed_loop(parm[])
 {
	new id = parm[0], aid = parm[1]
	new aliveI = is_user_alive(id), aliveA = is_user_alive(aid)

	if(!aliveI || !aliveA || !g_isLeeched[id][aid] || (!ActivePoke(id, BULBASAUR) && Pokemon[id]!=IVYSAUR && Pokemon[id]!=VENUSAUR) ){
		g_isLeeched[id][aid] = false
		return
	}

	new aName[32], iName[32], dmg = LEECH_SEED

	AddLvl(id, dmg)

	soundhit(id)
	soundhit(aid)

	MakeLine_Ent(0,id,aid,rope,1,1,10,5,0,0,255,0,100,0)

	get_user_name(id, iName, 31)
	get_user_name(aid, aName, 31)

	client_print(id,print_center,"You have leeched %s", aName)
	client_print(aid,print_center,"You have been leeched by %s", iName)

	screenflash(id, 0, 255, 0, 50)
	screenflash(aid, 0, 255, 0, 50)

	Heal(id, dmg)
	pokedamage(aid, id, dmg, "Leech Seed")

	new Float:tasktime = LEECH_SEED_TIME
	if(HasPokemon(id, VENUSAUR)!=-1)
		Growth(id, tasktime, VENUSAUR, false)
	else if(HasPokemon(id, IVYSAUR)!=-1 )
		Growth(id, tasktime, IVYSAUR, false)

	set_task(tasktime, "leech_seed_loop",0, parm, 2)
 }
 Vine_Whip(id)
 {
	new body, aid
	get_user_aiming(id, aid, body)

	if(is_user_alive(aid) && (Team(id)!=Team(aid) || FFon())){
		new Float:velocity[3]
		new Float:jump = VINE_WHIP_JUMP
		new whipdamage = VINE_WHIP_DAMAGE

		f_AddLvl(id, jump)
		AddLvl(id, whipdamage)

		bind_used(id,BELLSPROUT)

		pokedamage( aid, id, whipdamage, "Vine Whip")

		soundhit(id)
		soundhit(aid)

		MakeLine_Ent(0,id,aid,rope,1,1,10,10,10,0,255,0,100,0)

		pev(id, pev_velocity, velocity)

		if( !HeavyPoke(Pokemon[aid]) )
			velocity[2] += jump

		set_pev(aid, pev_velocity, velocity)
		set_pev(aid, pev_gaitsequence, 6)
	}
 }
 ///////////////////
 // Fire Pokemon //
 ///////////////////
 Fire_Blast(id)
 {
	bind_used(id,CHARIZARD)
	new Float: origin[3], Float: aim[3], Float: velocity[3], Ent

	pev(id, pev_origin, origin)
	pev(id, pev_v_angle, aim)

	Ent = fm_create_entity("info_target")

	if (!Ent) return PLUGIN_HANDLED

	set_pev(Ent, pev_classname, "poke_rock")
	set_pev(Ent, pev_globalname, "Fire Blast")
	fm_entity_set_model(Ent, MODELS[MDL_ROCK])

	new Float:MinBox[3] = {-1.0, -1.0, -1.0}
	new Float:MaxBox[3] = {1.0, 1.0, 1.0}
	set_pev(Ent, pev_mins, MinBox)
	set_pev(Ent, pev_maxs, MaxBox)

	fm_entity_set_origin(Ent, origin)
	set_pev(Ent, pev_angles, aim)

	set_pev(Ent, pev_solid, 1)
	set_pev(Ent, pev_movetype, 10)
	set_pev(Ent, pev_owner, id)

	velocity_by_aim(id, ROCK_THROW_VEC , velocity)
	set_pev(Ent, pev_velocity, velocity)

	emit_sound(id,CHAN_VOICE,SOUNDS[SND_TU_FIRE], 1.0, ATTN_NORM, 0, PITCH_NORM)

	if( !entity_in_water(id) ){
		// Trail on enity.
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMFOLLOW)		// TE_BEAMFOLLOW
		write_short(Ent)	// entity:attachment to follow
		write_short(fire)	// sprite index
		write_byte(10)	// life in 0.1's
		write_byte(10)		// line width in 0.1's
		write_byte(255)	//r,g,b
		write_byte(255)
		write_byte(255)
		write_byte(255)	// brightness
		message_end()

		//Glow the entity red
		fm_set_rendering(Ent, kRenderFxGlowShell, 255, 130, 5, kRenderNormal, 20)
	}

	return PLUGIN_HANDLED
 }
 Roar(id)
 {
	new pid
	pid = HasPokemon(id, GROWLITHE)
	if(pid==-1)
		pid = HasPokemon(id,ARCANINE)
	if(pid==-1)
		return
	bind_used(id,GROWLITHE)
	emit_sound(id, CHAN_VOICE, SOUNDS[SND_AG_DIE], 1.0, ATTN_NORM, 0, PITCH_NORM)

	#if MOD==NS
		new Float:energy
	#endif

	new ammo, bpammo, wpnid
	new players[MAX_PLAYERS], pnum, aid, Float:totake
	poke_get_players(players, pnum, "ai", Team(id))
	#if MOD==CS || MOD==NS
		new iWPNidx, wpn[32]
	#endif

	for ( new i = 0; i < pnum; i++ )
	{
		aid = players[i]
		#if MOD==CS
			wpnid = get_user_weapon(aid, ammo, bpammo)
			if(!wpnid)
				continue
			get_weaponname(wpnid,wpn,31)

			//can't do anything with these weapons
			if(knife_weapon(wpnid) || grenade_weapon(wpnid) || wpnid==CSW_C4)
				continue

			totake = float(LevelPercent(id,ammo,pid))

			iWPNidx = -1
			while ((iWPNidx = fm_find_ent_by_class(iWPNidx, wpn)) != 0) {
				if (aid == pev(iWPNidx, pev_owner)) {
					cs_set_weapon_ammo(iWPNidx, floatround(ammo-totake))
					break
				}
			}
			cs_set_user_bpammo(aid, wpnid, floatround(bpammo+totake))
		#endif
		#if MOD==DOD
			wpnid = get_user_weapon(aid,ammo,bpammo)
			if(!wpnid)
				continue
			if(knife_weapon(wpnid) || grenade_weapon(wpnid))
				continue
			ammo = dod_get_user_ammo(aid,wpnid)
			totake = float(LevelPercent(id,ammo,pid))
			dod_set_user_ammo(aid, wpnid, floatround(ammo-totake))
		#endif
		#if MOD==NS
			if(Team(aid)==1){//Marines
				wpnid = get_user_weapon(aid, ammo, bpammo)
				if(!wpnid)
					continue
				get_weaponname(wpnid,wpn,31)

				//can't do anything with these weapons
				if(knife_weapon(wpnid) || grenade_weapon(wpnid))
					continue

				totake = float(LevelPercent(id,ammo,pid))

				iWPNidx = -1
				while ((iWPNidx = fm_find_ent_by_class(iWPNidx, wpn)) != 0) {
					if (aid == pev(iWPNidx, pev_owner)) {
						ns_set_weap_clip(iWPNidx, floatround(ammo-totake))
						break
					}
				}
				ns_set_weap_reserve(aid, wpnid, floatround(bpammo+totake))
			}
			else{//Aliens
				energy = ns_get_energy(aid)
				totake = (energy*PlayersLevel(id,pid))*0.01
				ns_set_energy(aid, energy-totake)
			}
		#endif
		client_print(aid, print_center, "Someone roared at you")
		emit_sound(aid, CHAN_VOICE, SOUNDS[SND_AG_DIE], 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
 }
 
 Thunderbolt(id)
 {
	bind_used(id,RAICHU)
	emit_sound(id, CHAN_VOICE, SOUNDS[SND_SPARK], 1.0, ATTN_NORM, 0, PITCH_NORM)
	new players[MAX_PLAYERS], pnum, aid, damage = PlayersLevel(id, PlayersActive[id])
	poke_get_players(players, pnum, "ai", Team(id))
	for ( new i = 0; i < pnum; i++ )
	{
		aid = players[i]
		if(fm_entity_range(id, aid)<THUNDERBOLT_DISTANCE && fm_is_ent_visible(id, aid))
		{
			MakeLine_Ent(0,id,aid,lgtning,1,1,10,damage*2,5,250,250,10,100,0)

			pokedamage(aid, id, damage, "Thunderbolt")
			client_print(aid, print_center, "You were hit by a thunderbolt")
			emit_sound(aid, CHAN_VOICE, SOUNDS[SND_SPARK], 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
	}
 }
 Flamethrower(id)
 {
	if ( entity_in_water(id) ){
		client_print(id, print_chat, "%s You cannot use Flame Thrower while underwater",PREFIX)
		sounddeny(id)
		g_StopSkill[id] = true;
		return
	}

	new flamecount = 3

	new Float:fOrigin[3], Float:fVelocity[3]
	pev(id, pev_origin, fOrigin)
	velocity_by_aim(id, 35, fVelocity)

	new Float:fTemp[3], iFireOrigin[3]
	xs_vec_add(fOrigin, fVelocity, fTemp)
	FVecIVec(fTemp, iFireOrigin)

	new Float:fFireVelocity[3], iFireVelocity[3]
	velocity_by_aim(id, 100, fFireVelocity)
	FVecIVec(fFireVelocity, iFireVelocity)

	new parm[7]
	parm[0] = iFireOrigin[0]
	parm[1] = iFireOrigin[1]
	parm[2] = iFireOrigin[2]
	parm[3] = iFireVelocity[0]
	parm[4] = iFireVelocity[1]
	parm[5] = iFireVelocity[2]
	parm[6] = explode1

	create_flames( parm )
	if( flamecount-1 )
		set_task(0.1, "create_flames", 0, parm, 7, "a", flamecount-1)

	parm[0] = id
	parm[1] = 1
	flame_check( parm )
	if( flamecount-1 )
		set_task(0.1, "flame_check", 0, parm, 2, "a", flamecount-1)

	emit_sound(id, CHAN_VOICE, SOUNDS[SND_FLAME], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	end_rep_use(id, Pokemon[id], 3.0)
 }

 public create_flames(parm[])
 {
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(120)
	write_coord(parm[0])		//origin
	write_coord(parm[1])
	write_coord(parm[2])
	write_coord(parm[3])		//velocity
	write_coord(parm[4])
	write_coord(parm[5] + 5)
	write_short(parm[6])		//sprite
	write_byte(8)				//count
	write_byte(10)				//speed
	write_byte(100)				//noise
	write_byte(5)				//rendermode
	message_end()
 }
 public flame_check(parm[])
 {
	new id = parm[0]
	new flame = parm[1]	//this is 0 for smoke, 1 for fire

	//direct damage first
	new ent, body
	get_user_aiming(id, ent, body, 600)
	
	if(is_user_alive(ent))
	{
		if(flame==1)
			ApplyStatus( id, ent, STATUS_BURN )
		else
			screenflash(ent,255,255,255,255)
	}

	//now indirect damage
	new Players[32], iNum, target
	poke_get_players(Players, iNum, "ag")

	new Float:fOrigin[3], Float:fOrigin2[3]
	new temp[3], Float:fAim[3]
	new Float:fDistance = 600.0
	new iDistance

	for(new i = 0; i < iNum; ++i)
	{
		target = Players[i]
		if( target == id )
			continue

		pev(id, pev_origin, fOrigin)
		pev(target, pev_origin, fOrigin2)

		get_user_origin(id, temp, 3)
		IVecFVec(temp, fAim)

		if(get_distance_f(fOrigin, fOrigin2) > fDistance)
			continue 

		iDistance = get_distance_to_line(fOrigin, fOrigin2, fAim)
		if(iDistance > 40 || iDistance < 0 || !fm_is_ent_visible(id, target))
			continue 
			
		if(flame==1){
			pokedamage(target, id, 1, "Flame Thrower")
			if(Chance(id))
				ApplyStatus( id, target, STATUS_BURN )
		}
		else
			screenflash(target,255,255,255,255)
	}
 }
 Smoke_Screen(id)
 {
	new smokecount = 1

	new Float:fOrigin[3], Float:fVelocity[3]
	pev(id, pev_origin, fOrigin)
	velocity_by_aim(id, 35, fVelocity)
	
	new Float:fTemp[3], iFireOrigin[3]
	xs_vec_add(fOrigin, fVelocity, fTemp)
	FVecIVec(fTemp, iFireOrigin)

	new Float:fFireVelocity[3], iFireVelocity[3]
	velocity_by_aim(id, 100, fFireVelocity)
	FVecIVec(fFireVelocity, iFireVelocity)

	new parm[7]
	parm[0] = iFireOrigin[0]
	parm[1] = iFireOrigin[1]
	parm[2] = iFireOrigin[2]
	parm[3] = iFireVelocity[0]
	parm[4] = iFireVelocity[1]
	parm[5] = iFireVelocity[2]
	parm[6] = ballsmoke

	emit_sound(id, CHAN_VOICE, SOUNDS[SND_FLAME], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	create_flames( parm )
	if( smokecount-1 )
		set_task(0.1, "create_flames", 0, parm, 7, "a", smokecount-1)

	parm[0] = id
	parm[1] = 0
	flame_check( parm )
	if( smokecount-1 )
		set_task(0.1, "flame_check", 0, parm, 2, "a", smokecount-1)

	end_rep_use(id, Pokemon[id], 3.0)

	return PLUGIN_HANDLED
 }
 
 ///////////////////
 // Water Pokemon //
 ///////////////////
 Bubble_Beam(id)
 {
	new level = PlayersLevel(id,PlayersActive[id]), attack[30]
	new Float:bubdamage = float(SQUIRTLE_BUB_DAMAGE)
	if( ActivePoke(id, WARTORTLE) ){
		bubdamage *= WARTORTLE_BUBBLE_DAM_MULT	//because it shoots 10 times faster we make it weaker
		copy(attack, 29, "Water Gun")
	}
	else if( ActivePoke(id, BLASTOISE) ){
		bubdamage *= BLASTOISE_BUBBLE_DAM_MULT	//because it shoots 2 waterguns, we need to make it weaker than watergun
		copy(attack, 29, "Hydro Pump")
	}
	else {
		copy(attack, 29, "Bubble Beam")
	}

	new in_water = entity_in_water(id)

	if ( in_water ){
		new bubnum = SQUIRTLE_BUBBLES
		if( ActivePoke(id, WARTORTLE) )
			bubnum *= WARTORTLE_BUBBLE_NUM_MULT
		else if( ActivePoke(id, BLASTOISE) )
			bubnum *= BLASTOISE_BUBBLE_NUM_MULT
		bubnum += level
		bubbles[id] = bubnum
	}
	if(Pokemon[id]==SQUIRTLE)
		bind_used(id,SQUIRTLE)
	if(bubbles[id] > 0){

		new Float:f_sorigin[2][3], sorigin[2][3], Float:f_aimvec[3], aimvec[3];
		new bubsnum;

		get_user_origin(id, origin[id])
		get_user_origin(id, aimvec, 2)
		IVecFVec(aimvec, f_aimvec)

		bubsnum = get_distance(origin[id], aimvec)/15

		emit_sound(id, CHAN_VOICE, SOUNDS[SND_SWIM], 1.0, ATTN_NORM, 0, PITCH_NORM)

		if ( !in_water ){
			bubbles[id]--
			switch(Pokemon[id])
			{
				case SQUIRTLE:{
					message_begin(MSG_BROADCAST, SVC_TEMPENTITY)	//message begin
					write_byte(15)
					write_coord(origin[id][0])		// start position
					write_coord(origin[id][1])
					write_coord(origin[id][2])
					write_coord(aimvec[0])	// end position
					write_coord(aimvec[1])
					write_coord(aimvec[2])
					write_short(bubble)		// sprite index
					write_byte(bubsnum/2)		// count
					write_byte(1/2)		// life in 0.1's
					write_byte(5)		// scale in 0.1's
					write_byte(5)		// velocity along vector in 10's
					write_byte(5)	// randomness of velocity in 10's
					message_end()

					IVecFVec(origin[id], f_sorigin[0])

					Linedamage(id, f_sorigin[0], f_aimvec, level, floatround(bubdamage), attack)
				}
				case WARTORTLE,BLASTOISE:{
					new beams = 1
					if( ActivePoke(id, BLASTOISE) ){
						new Float:velocity[3]
						velocity_by_aim(id, 20, velocity)
						beams = 2
						f_sorigin[0][0] = origin[id][0] + velocity[1]
						f_sorigin[0][1] = origin[id][1] - velocity[0]
						f_sorigin[0][2] = origin[id][2] + 20.0
						f_sorigin[1][0] = origin[id][0] - velocity[1]
						f_sorigin[1][1] = origin[id][1] + velocity[0]
						f_sorigin[1][2] = origin[id][2] + 20.0
					}
					else{
						f_sorigin[0][0] = float(origin[id][0])
						f_sorigin[0][1] = float(origin[id][1])
						f_sorigin[0][2] = float(origin[id][2])
					}
					FVecIVec(f_sorigin[0], sorigin[0])
					FVecIVec(f_sorigin[1], sorigin[1])
					for(new i=0; i<beams; i++){
						Linedamage(id, f_sorigin[i], f_aimvec, level, floatround(bubdamage), attack)
						MakeLine(0,sorigin[i],aimvec,zbeam6,1,1,1,50+level,0,0,0,255,255,0)
					}

					end_rep_use(id, Pokemon[id], 1.0)
				}
			}
		}
		else {
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
			write_byte(114)
			write_coord(origin[id][0])				// min start position
			write_coord(origin[id][1])
			write_coord(origin[id][2])
			write_coord(aimvec[0])			// max start position
			write_coord(aimvec[1])
			write_coord(aimvec[2])
			write_coord(20)	// float height
			write_short(bubble)				// model index
			write_byte(bubsnum)					// count
			write_coord(100)				// speed
			message_end()

			IVecFVec(origin[id], f_sorigin[0])

			Linedamage(id, f_sorigin[0], f_aimvec, level, floatround(bubdamage), attack)
		}

		client_print(id,print_center,"You have %d %ss", bubbles[id], attack)

	}
	else {
		client_print(id, print_chat, "%s You are out of %s, go into water and keydown.",PREFIX,attack)
		bind_used(id,SQUIRTLE)
		sounddeny(id)
		g_StopSkill[id] = true;
	}
 }
 Recover(id)
 {
	new heal
 
	bind_used(id,STARYU)
	soundcure(id)
	screenflash(id, 128, 0, 128, 50)

	heal = PlayersLevel(id, PlayersActive[id])
	Heal(id, heal)
 }
 Confusion(id)
 {
	get_user_origin(id, origin[id])

	new aid, players[MAX_PLAYERS], pnum, applecount = 0
	if(Pokemon[id]==PSYDUCK || Pokemon[id]==GOLDUCK)
		poke_get_players(players,pnum,"ag")
	else
		poke_get_players(players,pnum,"agi",Team(id))

	new maxdist = CONFUSION_DISTANCE, distance
	AddLvl(id, maxdist)

	for(new i = 0; i<pnum; i++)
	{
		aid = players[i]

		get_user_origin(aid, origin[aid])

		distance = get_distance(origin[aid], origin[id])

		if(distance <= maxdist){
			pev(aid, pev_origin, confuse[aid])
			set_task(1.0,"Confuse",aid)
			set_task(3.0,"Confuse",aid)

			applecount++

			if( ActivePoke(id, SLOWBRO) && Chance(id) ){
				set_task(5.0,"Confuse",aid)
			}
		}
	}
	if(applecount){

		if(Pokemon[id]==PSYDUCK || Pokemon[id]==GOLDUCK)
			bind_used(id, PSYDUCK)
		else
			bind_used(id, SLOWPOKE)

		screenflash(id, 0, 0, 255, 50)
		soundcast(id)
		if(applecount>1)
			client_print(id, print_center, "You will confuse %d people", applecount)
		else
			client_print(id, print_center, "You will confuse someone")
	}
 }
 //////////////////////
 // Electric Pokemon //
 //////////////////////
 //--Voltorb Stuff--//
 public BlowUp(id)
 {
	new torigin[3]
	get_user_origin(id,torigin)

	emit_sound(id,CHAN_STATIC, SOUNDS[SND_SUCK], 1.0, ATTN_NORM, 0, PITCH_NORM)

	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte(TE_IMPLOSION)
	write_coord(torigin[0])
	write_coord(torigin[1])
	write_coord(torigin[2])
	write_byte(100)
	write_byte(20)
	write_byte(5)
	message_end()

	// random explosions
	message_begin( MSG_PVS, SVC_TEMPENTITY, torigin )
	write_byte(TE_EXPLOSION) // This just makes a dynamic light now
	write_coord( torigin[0] + random_num( -100, 100 ))
	write_coord( torigin[1] + random_num( -100, 100 ))
	write_coord( torigin[2] + random_num( -50, 50 ))
	write_short( eexplo )
	write_byte( random_num(0,20) + 20 )	// scale * 10
	write_byte( 12 )					// framerate
	write_byte(0)
	message_end()

	// lots of smoke
	message_begin( MSG_PVS, SVC_TEMPENTITY, torigin )
	write_byte(TE_SMOKE)
	write_coord( torigin[0] + random_num( -100, 100 ))
	write_coord( torigin[1] + random_num( -100, 100 ))
	write_coord( torigin[2] + random_num( -50, 50 ))
	write_short( steam1 )
	write_byte( 60 ) // scale * 10
	write_byte( 10 ) // framerate
	message_end()

	// blast circles
	message_begin( MSG_PAS, SVC_TEMPENTITY, torigin )
	write_byte(TE_BEAMCYLINDER)
	write_coord( torigin[0])
	write_coord( torigin[1])
	write_coord( torigin[2] - 16)
	write_coord( torigin[0])
	write_coord( torigin[1])
	write_coord( torigin[2] - 16 + VOLTORB_RADIUS)
	write_short( shockwave )
	write_byte( 0 )		// startframe
	write_byte( 0 )		// framerate
	write_byte( 6 )		// life
	write_byte( 16 )	// width
	write_byte( 0 )		// noise
	write_byte( 188 )
	write_byte( 220 )
	write_byte( 255 )
	write_byte( 255 )	//brightness
	write_byte( 0 )		// speed
	message_end()

	message_begin( MSG_PAS, SVC_TEMPENTITY, torigin )
	write_byte(TE_BEAMCYLINDER)
	write_coord( torigin[0])
	write_coord( torigin[1])
	write_coord( torigin[2] - 16)
	write_coord( torigin[0])
	write_coord( torigin[1])
	write_coord( torigin[2] - 16 + ( VOLTORB_RADIUS / 2 ))
	write_short( shockwave )
	write_byte( 0 )		// startframe
	write_byte( 0 )		// framerate
	write_byte( 6 )		// life
	write_byte( 16 )	// width
	write_byte( 0 )		// noise
	write_byte( 188 )
	write_byte( 220 )
	write_byte( 255 )
	write_byte( 255 )	//brightness
	write_byte( 0 )		// speed
	message_end()

	new parm[4]
	parm[0] = id
	parm[1] = torigin[0]
	parm[2] = torigin[1]
	parm[3] = torigin[2]
	set_task(0.5, "SDestructDamage", 0, parm, 4)

	return PLUGIN_CONTINUE
 }
 public SDestructDamage(parm[])
 {
	new Attack[32] = "Self-Destruct";

	new aid = parm[0], explode[3], Float:f_explode[3];
	explode[0] = parm[1];
	explode[1] = parm[2];
	explode[2] = parm[3];
	IVecFVec(explode, f_explode);

	if(HasPokemon(aid,ELECTRODE)!=-1)
		copy(Attack, 31, "Explosion");

	new maxdamage = VOLTORB_DAMAGE;
	AddLvl(aid, maxdamage);
	new damradius = VOLTORB_RADIUS;
	AddLvl(aid, damradius);

	AoEdamage(aid, f_explode, damradius, maxdamage, Attack, 0);
 }
 //////////////////
 // Rock Pokemon //
 //////////////////
 Rock_Throw(id)
 {
	bind_used(id,ONIX)
	new Float: origin[3], Float: aim[3], Float: velocity[3], Ent

	pev(id, pev_origin, origin)
	pev(id, pev_v_angle, aim)
	origin[2] += 20

	Ent = fm_create_entity("info_target")

	if (!Ent) return PLUGIN_HANDLED

	ChangeToBoulder(Ent, ONIX)
	set_pev(Ent, pev_classname, "poke_rock")
	fm_entity_set_model(Ent, MODELS[MDL_ROCK])
	set_pev(Ent, pev_owner, id)

	fm_entity_set_origin(Ent, origin)
	set_pev(Ent, pev_angles, aim)

	velocity_by_aim(id, ONIX_THROW, velocity)
	set_pev(Ent, pev_velocity, velocity)

	emit_sound(id,CHAN_VOICE, SOUNDS[SND_TU_FIRE], 1.0, ATTN_NORM, 0, PITCH_NORM)

	return PLUGIN_HANDLED
 }
 Rock_Slide(id)
 {
	bind_used(id,GOLEM)

	new Float:f_aimvec[3], Ent
	new rockammount = 1+(PlayersLevel(id, PlayersActive[id]) / GOLEM_ROCK_LEVEL)

	get_user_origin(id, origin[id]);
	get_user_origin(id, aim[id], 3);

	if(-50>aim[id][0]-origin[id][0]>50)			//only change it if they are at least that far away
		aim[id][0] += ( ( aim[id][0] - origin[id][0] > 0 ) ? -50 : 50 );
	if(-50>aim[id][1]-origin[id][1]>50)			//only change it if they are at least that far away
		aim[id][1] += ( ( aim[id][1] - origin[id][1] > 0 ) ? -50 : 50 );
	if(-50>aim[id][2]-origin[id][2]>50)			//only change it if they are at least that far away
		aim[id][2] += ( ( aim[id][2] - origin[id][2] > 0 ) ? -50 : 50 );
	else
		aim[id][2] += 40;

	for(new i=0; i<rockammount; i++){
		Ent = fm_create_entity("info_target")

		if (!Ent) continue

		set_pev(Ent, pev_owner, id)

		IVecFVec(aim[id], f_aimvec)
		f_aimvec[0] += random_float(-100.0,100.0)
		f_aimvec[1] += random_float(-100.0,100.0)

		fm_entity_set_origin(Ent, f_aimvec)

		ChangeToBoulder(Ent, GOLEM)
		set_pev(Ent, pev_velocity, Float:{0.0,0.0,1000.0})

		set_task(0.1, "CheckBoulder", Ent)
	}

	return PLUGIN_HANDLED
 }
 public CheckBoulder(ent)
 {
	new Float:velocity[3]
	pev(ent, pev_velocity, velocity)
	if(velocity[2]<1 || velocity[0] || velocity[1]){
		emit_sound(ent,CHAN_VOICE, SOUNDS[SND_TU_FIRE], 0.5, ATTN_NORM, 0, PITCH_NORM)
		set_pev(ent, pev_velocity, Float:{0.0,0.0,-50.0} )
		set_pev(ent, pev_classname, "poke_rock")
		fm_entity_set_model(ent, MODELS[MDL_ROCK])
	}
	else
		set_task(0.1, "CheckBoulder", ent)
 }
 ChangeToBoulder(Ent, pid)
 {
	if(pid==ONIX)
		set_pev(Ent, pev_globalname, "Rock Throw")
	else
		set_pev(Ent, pev_globalname, "Rock Slide")

	set_pev(Ent, pev_mins, Float:{-10.0, -10.0, -10.0})
	set_pev(Ent, pev_maxs, Float:{10.0, 10.0, 10.0})

	set_pev(Ent, pev_solid, SOLID_TRIGGER)
	set_pev(Ent, pev_movetype, MOVETYPE_TOSS)

	return PLUGIN_HANDLED
 }
 /////////////////////
 // Psychic Pokemon //
 /////////////////////
 Teleport(id)
 {
	if(PassTest(id, 1)){
		get_user_origin(id, origin[id])
		get_user_origin(id, aim[id], 3)

		//Thanks to WC3 mod
		// Change coordinates to make sure player won't get stuck in the ground/wall
		if(-50>aim[id][0]-origin[id][0]>50)			//only change it if they are at least that far away
			aim[id][0] += ( ( aim[id][0] - origin[id][0] > 0 ) ? -50 : 50 );
		if(-50>aim[id][1]-origin[id][1]>50)			//only change it if they are at least that far away
			aim[id][1] += ( ( aim[id][1] - origin[id][1] > 0 ) ? -50 : 50 );
		if(-50>aim[id][2]-origin[id][2]>50)			//only change it if they are at least that far away
			aim[id][2] += ( ( aim[id][2] - origin[id][2] > 0 ) ? -50 : 50 );
		else
			aim[id][2] += 40;

		set_bind(id, WAIT_TIME)
		soundcast(id)

		screenflash(id, 255, _, 255, 100, 100.0, 5)

		set_task( ABRA_TELEPORT_TIME , "finish_teleport",id)
	}
	else{
		sounddeny(id)
		g_StopSkill[id] = true;
	}

 }
 public finish_teleport(id)
 {
	if(PassTest(id, 0) && is_user_alive(id)){
		end_delay(id,ABRA)

		get_user_origin(id, origin[id])
		set_user_origin(id, aim[id])

		MakeLine(0,origin[id],aim[id],trail,0,0,10,15,0,255,255,255,255,0)

		screenflash(id, 0, 0, 0, 0)
		soundcast(id)

		poke_UnStuck(id)
	}
 }
 Psybeam(id)
 {
	if(pev_valid(PlayerEnt[id])){
		sounddeny(id)
		g_StopSkill[id] = true;
		return
	}

	new Float:fl_Origin[3], Float:fl_Angles[3], Float:fl_vAngle[3]
	new Float:VecMins[3] = {-2.0,-2.0,-2.0}
	new Float:VecMaxs[3] = {2.0,2.0,2.0}

	// Get users postion and angles (angles are probably not needed in this case)
	pev(id, pev_origin, fl_Origin)
	pev(id, pev_angles, fl_Angles)
	pev(id, pev_v_angle, fl_vAngle)

	new newEnt = fm_create_entity("info_target")
	if(newEnt==0)
		return

	PlayerEnt[id] = newEnt

	set_pev(newEnt, pev_classname, "psy_beam")
	fm_entity_set_model(newEnt, MODELS[MDL_SKULL])

	// Set entity size
	set_pev(newEnt, pev_mins, VecMins)
	set_pev(newEnt, pev_maxs, VecMaxs)

	// Change height of entity origin to hands
	fl_Origin[2] += 6

	// Set entity postion and angles
	fm_entity_set_origin(newEnt, fl_Origin)
	set_pev(newEnt, pev_angles, fl_Angles)
	set_pev(newEnt, pev_v_angle, fl_vAngle)

	// Set properties of the entity
	set_pev(newEnt, pev_solid, 2)
	set_pev(newEnt, pev_movetype, 5)
	set_pev(newEnt, pev_rendermode, 5)
	set_pev( newEnt, pev_renderamt, 255.0)
	set_pev( newEnt, pev_scale, 1.20)
	set_pev(newEnt, pev_owner, id)

	new Float:Velocity[3]
	new Speed = PSYBEAM_SPEED

	velocity_by_aim(id, Speed, Velocity)
	set_pev(newEnt, pev_velocity, Velocity)

	// Pass varibles used to guide entity with
	new args[3]
	args[0] = id
	args[1] = newEnt
	args[2] = Speed

	set_task(0.1, "guide_beam", newEnt, args, 3)
	fm_attach_view(id, newEnt)

	// Trail on enity. It's flawed by not being removable, so make it last long.
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(22)		// TE_BEAMFOLLOW
	write_short(newEnt)	// entity:attachment to follow
	write_short(trail)	// sprite index
	write_byte(50)	// life in 0.1's
	write_byte(7)		// line width in 0.1's
	write_byte(255)	//r,g,b
	write_byte(255)
	write_byte(255)
	write_byte(255)	// brightness
	message_end()

	soundcast(id)
	set_bind(id, WAIT_TIME)
	screenflash(id, 255, 0, 255, 100)
 }
 public guide_beam(args[])
 {
	new id = args[0]
	new entID = args[1]
	new speed = args[2]

	if ( !pev_valid(entID) ) return

	if ( !is_user_connected(id) || !is_user_alive(id) || (!ActivePoke(id, KADABRA) && Pokemon[id]!=ALAKAZAM)) {
		touches(entID, 0)
		return
	}

	new Float:Velocity[3], Float:Angles[3]
	velocity_by_aim(id, speed, Velocity)
	pev(id, pev_v_angle, Angles)
	set_pev(entID, pev_velocity, Velocity)
	set_pev(entID, pev_angles, Angles)

	set_task(0.1, "guide_beam", entID, args, 3)
 }
 Barrier(id)
 {
	new in_area = 0, newEnt = -1
	new Float:fl_Origin[3]
	pev(id, pev_origin, fl_Origin)

	#if LIMIT_BARRIER > 0
		new gname[25]
		while((newEnt = fm_find_ent_in_sphere(newEnt, fl_Origin, 500.0)) != 0){
			pev(newEnt, pev_globalname, gname, 24)
			if(equali(gname,"mime_wall"))
				in_area++
		}
		if(in_area > LIMIT_BARRIER){
			client_print(id, print_center, "Too many barriers nearby")
			return
		}
		newEnt = -1
		in_area = 0
	#endif

	while((newEnt = fm_find_ent_by_class(newEnt, "pokemod_ent")) != 0){
		in_area++
	}
	if(in_area > MAX_POKE_ENTS){
		client_print(id, print_center, "Too many entities on map")
		return
	}

	soundcast(id)
	bind_used(id,MRMIME)
	new mime_num = HasPokemon(id, MRMIME)

	new Float:velocity[3]
	new Float:VecMins[3] = {-1.0,-1.0,-30.0}
	new Float:VecMaxs[3] = {1.0,1.0,30.0}

	//lets move it a little away from them
	velocity_by_aim(id, 50, velocity)

	new Float:wall_hp = 1.0*BARRIER_MIN_HP + LevelPercent( id, BARRIER_MAX_HP-BARRIER_MIN_HP, mime_num )

	pev(id, pev_origin, fl_Origin)
	fl_Origin[0] += velocity[0]
	fl_Origin[1] += velocity[1]
	fl_Origin[2] += velocity[2]

	newEnt = fm_create_entity("info_target")

	if(!pev_valid(newEnt))
		return

	set_pev(newEnt, pev_classname, "pokemod_ent")
	set_pev(newEnt, pev_globalname, "mime_wall")
	fm_entity_set_model(newEnt, MODELS[MDL_HAIR])

	// Set entity size
	set_pev(newEnt, pev_mins, VecMins)
	set_pev(newEnt, pev_maxs, VecMaxs)

	// Set entity postion and angles
	fm_entity_set_origin(newEnt, fl_Origin)

	// Set properties of the entity
	set_pev(newEnt, pev_solid, SOLID_BBOX)
	set_pev(newEnt, pev_movetype, MOVETYPE_FLY)
	set_pev(newEnt, pev_scale, 1.20)

	set_pev(newEnt, pev_takedamage, 1.0)
	set_pev(newEnt, pev_health, wall_hp)
 }
 /////////////////
 // Bug Pokemon //
 /////////////////
 Poison_Powder(id)
 {
	bind_used(id, VENONAT)

	new powdernum = POISON_POWDERS

	//make one immediately
	make_powder(id)
	powdernum--

	set_task(0.5,"make_powder", id, EMPTY, 0, "a", powdernum)
 }
 public make_powder(id)
 {
	if(!PMon() || !is_user_alive(id))
		return

	new Float:fl_Origin[3], ptime = POWDER_TIME

	pev(id, pev_origin, fl_Origin)

	new newEnt = fm_create_entity("info_target")

	set_pev(newEnt, pev_classname, "sleep_powder")
	fm_entity_set_model(newEnt, MODELS[MDL_POWDER])

	// Change height of entity origin to hands
	fl_Origin[2] += 6

	// Set entity postion
	fm_entity_set_origin(newEnt, fl_Origin)

	// Set properties of the entity
	set_pev( newEnt, pev_rendermode, 5)
	set_pev( newEnt, pev_sequence,0)
	set_pev( newEnt, pev_renderamt, 255.0)
	set_pev( newEnt, pev_scale, 1.20)
	set_pev( newEnt, pev_owner, id)

	check_powder(newEnt)
	set_task(0.5,"check_powder",newEnt, EMPTY, 0 , "a", 2*ptime-1)
	set_task(ptime*1.0,"poke_remove_entity",newEnt+REMOVE_TASK)
 }
 public check_powder(spowder)
 {
	if(!pev_valid(spowder))
		return
	new id = pev(spowder, pev_owner)

	new Float:poison_time = get_ppcvar_float(pm_poisontime)
	new Float:sleep_time = get_ppcvar_float(pm_sleeptime)
	new range = POWDER_RANGE
	AddLvl(id, range)

	new bool:sleeppowder = false
	if(HasPokemon(id, VENOMOTH)!=-1)
		sleeppowder = true

	new aid, players[MAX_PLAYERS], pnum
	poke_get_players(players,pnum,"agi",Team(id))

	for(new i = 0; i<pnum; i++)
	{
		aid = players[i]

		if( fm_entity_range(spowder,aid) < range ) {

			if(!g_Status[aid][STATUS_POISON]){
				ApplyStatus( id, aid, STATUS_POISON, poison_time )
				client_print(aid,print_center,"You have walked into poison powder")
			}

			if(sleeppowder && !g_Status[aid][STATUS_ASLEEP]){
				ApplyStatus( id, aid, STATUS_ASLEEP, sleep_time )
				client_print(aid,print_center,"You have walked into sleep powder")
			}
		}
	}
 }
 ////////////////////
 // Poison Pokemon //
 ////////////////////
 ///////////////////
 // Ghost Pokemon //
 ///////////////////
 NightShade(id)
 {
	if(BindUsed[id]>0.0){
		fm_set_rendering(id)
		screenflash(id)
	}
	else{
		new max = clamp(MAX_INVIS, 1, 255)
		new min = clamp(MIN_INVIS, 0, max)
		new fade, level
		new mult
		mult = (max - min)/9
		switch(gtime){
			case 0: fade = max
			case 1,19: fade = mult*8 + min
			case 2,18: fade = mult*7 + min
			case 3,17: fade = mult*6 + min
			case 4,16: fade = mult*5 + min
			case 5,15: fade = mult*4 + min
			case 6,14: fade = mult*3 + min
			case 7,13: fade = mult*2 + min
			case 8,9,11,12: fade = mult + min
			case 10: fade = min
		}

		level = PlayersLevel(id, PlayersActive[id])
		fade -= level

		fade = clamp(fade, min, max)	//don't want to set it to something too high or low

		fm_set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, fade)
		if(fade<33)	//not too dark plz
			fade = 33

		screenflash(id, 0, 0, 0, 255-fade, 2.0)
	}
 }
 Hypnosis(id)
 {
	new body, aid
	get_user_aiming(id, aid, body, HAUNTER_MAX_DISTANCE)

	if(!is_user_alive(aid)) return

	if(!g_Status[aid][STATUS_ASLEEP]){
		if(Team(id)==Team(aid)) return

		soundcast(id)
		bind_used(id,HAUNTER)
		ApplyStatus( id, aid, STATUS_ASLEEP, get_ppcvar_float(pm_sleeptime) )

		client_print(id,print_center,"They are now asleep")
		client_print(aid,print_center,"You have been put to sleep")
	}
	if( ActivePoke(id, GENGAR) )
		Dream_eat(aid, id)
 }
 Dream_eat(aid, id)
 {
	soundcure(id)

	new eatdamage = DREAM_EAT_DAMAGE
	AddLvl(id, eatdamage)

	if(pokedamage( aid, id, eatdamage, "Dream Eater"))
		Heal(id, eatdamage)

	client_print(id,print_center,"You ate a dream")
	client_print(aid,print_center,"Your dream has been eaten")
 }
 ////////////////////
 // Normal Pokemon //
 ////////////////////
 PayDay(aid, damage)
 {
	if(DisAllowSkill(aid, false, MEOWTH) || PokeInfo[MEOWTH]&PI_DISABLE )
		return

	new players[MAX_PLAYERS], pnum, tid, extra
	poke_get_players(players, pnum, "ae", Team(aid))

	for ( new i = 0; i < pnum; i++ )
	{
		tid = players[i]
		if(ActivePoke(tid, MEOWTH) || ActivePoke(tid, PERSIAN))
		{
			extra = damage
			AddLvl(tid, extra)

			if(Pokemon[tid]==MEOWTH || Pokemon[tid]==PERSIAN)
				extra = floatround(extra*MEOWTH_BONUS)

			Pay(tid, extra)
		}
	}
 }
 Scratch(id, weapon)
 {
	if(knife_weapon(weapon)){
		set_pev(id, pev_velocity, Float:{0.0,0.0,0.0})
	}
 }
 Egg_Bomb(id)
 {
	if(EggBomb[id]==0)
		give_grenade(id)
	else if(EggBomb[id]!=id && pev_valid(EggBomb[id])){
		//stop them from geting a nade immediately
		bind_used(id, CHANSEY)

		soundcast(id)
		set_pev(EggBomb[id], pev_dmgtime, 0.1)
		set_pev(EggBomb[id], pev_nextthink, 0.1)
		set_pev(EggBomb[id], pev_owner, id)
		EggBomb[id] = 0
	}
 }
 public egg_bomb_nade(id)
 {
	if(EggBomb[id]==0)
		return
	if(!PMon() || !is_user_alive(id)){
		set_pev(EggBomb[id], pev_dmgtime, 0.1)
		set_pev(EggBomb[id], pev_nextthink, 0.1)
		set_pev(EggBomb[id], pev_owner, id)
		bind_used(id,CHANSEY)
	}
	else {
		if(pev_valid(EggBomb[id])){
			new Float:timer
			pev(EggBomb[id], pev_nextthink, timer)
			timer += 2.0
			set_pev(EggBomb[id], pev_nextthink, timer)
			set_task(1.0, "egg_bomb_nade", id)
		}
	}
 }
 public egg_bomb_change(parm[])
 {
	new nade = parm[0]

	EggBomb[parm[1]] = nade

	fm_entity_set_model(nade, MODELS[MDL_POKEBALL])
	set_pev(nade, pev_solid, SOLID_BBOX)
	set_pev(nade, pev_owner, 0)

	fm_entity_set_size(nade,Float:{-5.0,-5.0,-5.0},Float:{5.0,5.0,5.0})

	set_pev(nade, pev_scale, 0.2)

	egg_bomb_nade(parm[1])
 }
 
 public delayed_grenade(parm[])
	give_grenade(parm[0],parm[1],bool:parm[2]);
 give_grenade(id, how_many=1, bool:add_with=false)
 {
	new old_amount, new_amount
	#if MOD==CS
		give_item(id, "weapon_hegrenade")
		old_amount = cs_get_user_bpammo(id, CSW_HEGRENADE)
		new_amount = add_with ? (old_amount+how_many) : ( max(how_many,old_amount) )
		cs_set_user_bpammo(id, CSW_HEGRENADE, new_amount)
		console_print(0, "colby new %d old %d", new_amount, old_amount)
	#endif
	#if MOD==DOD
		new wpnid
		if(Team(id)==2){
			give_item(id, "weapon_stickgrenade")
			wpnid = DODW_STICKGRENADE
		}
		else{
			give_item(id, "weapon_handgrenade")
			wpnid = DODW_HANDGRENADE
		}
		old_amount = dod_get_user_ammo(id,wpnid)
		new_amount = add_with ? (old_amount+how_many) : ( max(how_many,old_amount) )
		dod_set_user_ammo(id, wpnid, new_amount)
	#endif
	#if MOD==NS
		if(Team(id)==1){
			new wpn[32], bpammo
			get_user_weapon(id, old_amount, bpammo)
			get_weaponname(WEAPON_GRENADE,wpn,31)

			ns_give_item(id, "weapon_grenade")
			new_amount = add_with ? (old_amount+how_many) : ( max(how_many,old_amount) )
			new iWPNidx = -1
			while ((iWPNidx = fm_find_ent_by_class(iWPNidx, wpn)) != 0) {
				if (id == pev(iWPNidx, pev_owner)) {
					ns_set_weap_clip(iWPNidx, new_amount)
				}
			}
		}
	#endif
 }
 
 /////////////////////////////////
 //  And now the dissorganized  //
 /////////////////////////////////
 
 Growth(id, Float:time, pid, bool:say_reduce=true)
 {
	if(time==1.0)
		return true

	new Float:oldtime = time
	time -= oldtime * f_LevelPercent(id, GROWTH_REDUCE, HasPokemon(id,pid))

	if(time<1.0)
		time = 1.0

	if(oldtime > time){
		if(say_reduce)
			client_print(id, print_center, "Growth has reduced your wait by %.1fs",oldtime-time)
	}
	else
		time = oldtime

	return true
 }
 
 Absorb(aid, id)
 {
	new armor = get_user_armor(id)
	new level = PlayersLevel(aid, HasPokemon(aid,TANGELA))
	new totake = (armor*level)/(TotalLevels+1)

	if(Pokemon[aid]==TANGELA){
		if(level<armor)
			clamp(totake, level, armor)
		else
			totake = armor
	}

	Repair(aid, totake)
	set_user_armor(id, armor-totake)

	soundhit(id)
	soundhit(aid)

	MakeLine_Ent(0,id,aid,rope,1,1,10,5,10,0,255,200,255,0)
 }
 
 Take_Rage(id, aid, damage)
 {
	if(id==aid)
		return

	new ragenums = damage / RAGE_FACTOR

	rage[id] += ragenums

	if(rage[id] > MAX_RAGE)
		rage[id] = MAX_RAGE

	client_print(id,print_center,"Your rage is at %d extra damage", rage[id])
 }
 
 Do_Rage(aid, id)
 {
	if(rage[aid]){
		client_print(aid,print_center,"Your rage did %d extra damage", pokedamage( id, aid, rage[aid], "Rage"))
	}
 }
 
 Wrap(attacker, id)
 {
	if( Chance(id) ){
		ApplyStatus( id, attacker, STATUS_PARALYZE, 1.0 );
		client_print( id, print_center, "You wrapped someone up" );
		client_print( attacker, print_center, "You have been wrapped" );
	}
 }
 
 stock Bide(aid, id)
 {
	new edamage = (maxhp[aid] - Health(aid)) / BIDE_FACTOR
	if(edamage>0 && MaxChance(aid,edamage)){
		MakeLine_Ent(0,id,aid,rope,1,1,10,5,10, 139,59,19, 255,0)
		client_print(aid,print_center,"Your bide did %d extra damage", pokedamage( id, aid, edamage, "Bide"))
	}
 }
 Acid(aid, id)
 {
	if(MaxChance(aid,50) && !g_Status[id][STATUS_POISON]){
		ApplyStatus( aid, id, STATUS_POISON, get_ppcvar_float(pm_poisontime) )
		client_print(aid,print_center,"You poisoned an enemy")
		client_print(id,print_center,"You have been poisoned")
		MakeLine_Ent(0,id,aid,arbok,1,1,5,20,0, 0,200,150, 100, 0)
	}
 }
 
 Counter(id, aid)
 {
	if(MaxChance(id,rage[id])){
		client_print(id,print_center,"Your counter did %d damage", pokedamage( aid, id, rage[id]/COUNTER_FACTOR, "Counter"))
	}
 }
 
 Defense_Curl(id, damage)
 {
	Repair(id, damage / DEFENSE_CURL)
 }
 
 Harden(id)
 {
	new armr = get_user_armor(id);
	if( !armr ){
		sounddeny(id);
		client_print(id, print_center, "You need to have armor to swap");
		g_StopSkill[id] = true;
		return;
	}

	if(Pokemon[id]==GRAVELER || Pokemon[id]==GOLEM)
		bind_used(id, GRAVELER);
	else
		bind_used(id, METAPOD);

	new hp = Health(id);

	maxhp[id] = armr;
	set_user_health(id, maxhp[id]);
	set_user_armor(id, hp);
 }
  
 Flash(aid, id, damage)
 {
	if(MaxChance(aid,damage)){
		screenflash(id, 255,255,255, damage, FLASH_TIME);
		client_print(aid,print_center,"You hit someone with flash");
		client_print(id,print_center,"You were hit by a flash of light");
	}
 }
 
 Reflect(id, weapon, damage)
 {
	new max
	if(Pokemon[id]==ALAKAZAM)
		max = damage + REFLECT_ACTIVE
	else
		max = damage
	if(MaxChance(id, max) && grenade_weapon(weapon)){
		screenflash(id, 255, 0, 255, 50)
		Heal(id,damage)
		client_print(id,print_center,"You reflected shrapnel from a grenade")
	}
 }
 
 String_Shot(aid, id)
 {
	if(Chance(aid) && !g_Status[id][STATUS_SLOW]){
		client_print(id,print_center,"You were hit by a string shot")
		client_print(aid,print_center,"You hit someone with string shot")

		ApplyStatus( aid, id, STATUS_SLOW, STRING_SHOT_TIME )

		soundhit(id)
		soundhit(aid)

		MakeLine_Ent(0,id,aid,arbok,1,1,10,10,0,89,89,89,100,0)
	}
 }
 
 Guillotine(aid, id, weapon, damage)
 {
	if(MaxChance(aid, damage) && knife_weapon(weapon))
		pokedamage( id, aid, Health(id), "Guillotine")
 }
 
 stock Poison_Sting(id, aid)
 {
	if(Chance(id) && !g_Status[aid][STATUS_POISON]){
		ApplyStatus( id, aid, STATUS_POISON, get_ppcvar_float(pm_poisontime) )
		client_print(id,print_center,"You poisoned an enemy")
		client_print(aid,print_center,"You have been poisoned")
		MakeLine_Ent(0,id,aid,arbok,1,1,5,20,0,150,0,150,100,0)
	}
 }
 
 Gas(id)
 {
	if(BindUsed[id]>0.0)
		return

	new bool:smog = false
	new bool:poison = false

	if(	( ActivePoke(id, KOFFING) && !SkillDisabled( KOFFING ) )
	||	( ActivePoke(id, WEEZING) && !SkillDisabled( WEEZING ) )
	)
		smog = true

	if(	( ActivePoke(id, WEEZING) && !SkillDisabled( WEEZING ) )
	||	( ActivePoke(id, GRIMER) && !SkillDisabled( GRIMER ) )
	||	( ActivePoke(id, MUK) && !SkillDisabled( MUK ) )
	)
		poison = true

	if( !smog && !poison )
		return;

	get_user_origin(id, origin[id])
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
	write_byte(TE_SPRITE)
	write_coord(origin[id][0]) // start position
	write_coord(origin[id][1])
	write_coord(origin[id][2])
	write_short(gas) // sprite index
	write_byte(10) // scale in 0.1's
	write_byte(100) // brightness
	message_end()

	new aid, playersa[MAX_PLAYERS], pnuma
	poke_get_players(playersa,pnuma,"agi",Team(id))

	new Float:poison_time = get_ppcvar_float(pm_poisontime)
	new distance
	new maxdist = 300
	AddLvl(id, maxdist)

	for(new ick = 0; ick<pnuma; ick++)
	{
		aid = playersa[ick]

		get_user_origin(aid, origin[aid])

		distance = get_distance(origin[aid], origin[id])
		if(distance <= maxdist){
			if(smog){
				client_print(aid,print_center,"You walked into smog")
				screenflash(aid, 139, 59, 19, 222, 1.0)
			}
			if(poison && !g_Status[aid][STATUS_POISON]){
				ApplyStatus( id, aid, STATUS_POISON, poison_time )
				client_print(id,print_center,"You poisoned an enemy")
				client_print(aid,print_center,"You have been poisoned")
			}
		}
	}
 }
 
 Glare(id)
 {
	new body, aid
	get_user_aiming(id, aid, body)
	if(is_user_alive(aid) && Team(id)!=Team(aid)){
		bind_used(id,ARBOK)
		client_print(aid, print_center, "Someone Glared at you")
		ApplyStatus( id, aid, STATUS_PARALYZE, 1.0 )
	}
 }
 
 Bite(id, victim)
 {
	new bite = LEECHLIFE
	new Attack[11], addon[6]
	if(ActivePoke(id, GOLBAT)){
		bite = BITE
		copy(Attack, 10, "Bite")
		copy(addon, 5, "n")
	}
	else{
		copy(Attack, 10, "Leechlife")
		copy(addon, 5, "d")
	}

	client_print(victim, print_center, "You have been %s%s",Attack, addon)

	Heal(id, pokedamage(victim, id, bite, Attack) );
 }
 
 Hyper_Fang(id, aid, damage, weapon)
 {
	new div = maxhp[id] / HYPER_FANG
	if(Pokemon[aid]==RATICATE)
		div = maxhp[id] / SUPER_FANG
	if(damage<div && knife_weapon(weapon)){
		if(Pokemon[aid]==RATICATE)
			pokedamage(id, aid, div-damage, "Super Fang")
		else
			pokedamage(id, aid, div-damage, "Hyper Fang")
	}
 }
  
 Double_Edge(aid, id, weapon)
 {
	if(is_user_alive(id) || knife_weapon(weapon)) return

	new amount
	new level
	new haspoke = HasPokemon(aid, DODUO)
	if(haspoke!=-1)
		level = PlayersLevel(aid, haspoke)
	else{
		haspoke = HasPokemon(aid, DODRIO)
		level = PlayersLevel(aid, haspoke)
	}

	if(Pokemon[aid]==DODUO || Pokemon[aid]==DODRIO)
		level *= 2

	#if MOD==CS
		amount = cs_get_user_bpammo(aid, weapon)
		if(amount==0 && grenade_weapon(weapon)){
			give_grenade(aid)
			amount = 1
		}
		cs_set_user_bpammo(aid, weapon, amount+level)
	#endif
	#if MOD==DOD
		amount = dod_get_user_ammo(aid, weapon)
		if(amount==0 && grenade_weapon(weapon)){
			give_grenade(aid)
			amount = 1
		}
		dod_set_user_ammo(aid, weapon, amount+level)
	#endif
	#if MOD==NS
		amount = ns_get_weap_reserve(aid, weapon)
		if(amount==0 && grenade_weapon(weapon)){
			give_grenade(aid)
			amount = 1
		}
		ns_set_weap_reserve(aid, weapon, amount+level)
	#endif
 }
 
 Tri_Attack(aid, weapon)
 {
	if(knife_weapon(weapon)) return

	new wpn[32], ammo, bpammo
	get_user_weapon(aid, ammo, bpammo)
	get_weaponname(weapon,wpn,31)

	new addition = 1
	if(Pokemon[aid]==DODRIO)
		addition++

	if(PokeChance(aid, HasPokemon(aid, DODRIO))){

		//can't do anything with these weapons
		if(grenade_weapon(weapon)){
			new parm[3];
			parm[0] = aid;
			parm[1] = addition;
			parm[2] = 1;
			set_task(0.1, "delayed_grenade", 0, parm, 3);
//			give_grenade(aid, addition, true)
			return
		}
		#if MOD==CS
			new iWPNidx = -1
			while ((iWPNidx = fm_find_ent_by_class(iWPNidx, wpn)) != 0) {
				if (aid == pev(iWPNidx, pev_owner)) {
					cs_set_weapon_ammo(iWPNidx, ammo+addition)
				}
			}
		#endif
		#if MOD==DOD
			new amount = dod_get_user_ammo(aid, weapon)
			dod_set_user_ammo(aid, weapon, amount+addition)
		#endif
		#if MOD==NS
			new iWPNidx = -1
			while ((iWPNidx = fm_find_ent_by_class(iWPNidx, wpn)) != 0) {
				if (aid == pev(iWPNidx, pev_owner)) {
					ns_set_weap_clip(iWPNidx, ammo+addition)
				}
			}
		#endif
	}
 }
 
 Fly(id)
 {
	new jumpvec = FLY;
	new button = pev(id, pev_button);
	AddLvl(id, jumpvec);

	new Float:velocity[3], Float:vec[3];
	pev(id, pev_velocity, velocity);

	if(velocity[2] < 1.5*jumpvec)
		velocity[2] += jumpvec;

	if(button&IN_FORWARD && sqroot(floatround(velocity[0]*velocity[0] + velocity[1]*velocity[1])) < jumpvec){
		velocity_by_aim(id, jumpvec , vec);
		velocity[0] += vec[0];
		velocity[1] += vec[1];
	}

	set_pev(id, pev_velocity, velocity);
	set_pev(id, pev_gaitsequence, 6);

	#if FLY_FLAP==1
		g_lastSkill[id] = 0.0;
		g_StopSkill[id] = true;
	#endif
 }
 
 Rest(id)
 {
	new rest = REST
	screenflash(id, 0, 0, 0, 255-LevelPercent(id, 222, PlayersActive[id]))
	Heal(id, rest)
 }

 Splash(id)
 {
	new flag = pev(id, pev_flags);

	if( flag&FL_ONGROUND ){
		if(MaxChance(id, 50)){
			Heal(id, LevelPercent(id, 5, PlayersActive[id]));
		}
		emit_sound(id, CHAN_VOICE, SOUNDS[SND_WADE], 0.5, ATTN_NORM, 0, PITCH_NORM);
		set_pev(id, pev_velocity, Float:{0.0,0.0,1.0} );
	}
 }

 Substitute(id)
 {
	if(HasPokemon(id, BUTTERFREE)!=-1 && Health(id) < maxhp[id]/SUBSTITUTE){
		EscapeRope(id, 0)
		bind_used(id,BUTTERFREE)
	}
	else
		client_print(id, print_center, "Your HP is not low enough (%d)",maxhp[id]/SUBSTITUTE)
 }
 
 Gust(id)
 {
	new gust = PlayersLevel(id, PlayersActive[id]) / GUST_FACTOR
	new Float:velocity[3], Float:Cvelocity[3], Attack[32]

	bind_used(id, PIDGEY)
	emit_sound(id, CHAN_VOICE, SOUNDS[SND_JUMPLAND], 1.0, ATTN_NORM, 0, PITCH_NORM)

	if(Pokemon[id]==PIDGEY){
		copy(Attack, 32, "Gust")
	}
	else{
		copy(Attack, 32, "Whirlwind")
	}

	velocity_by_aim(id, gust*GUST_VELOCITY, velocity)

	new players[MAX_PLAYERS], pnum, tid
	poke_get_players(players, pnum ,"ag")

	for(new i=0; i<pnum; i++){
		tid = players[i]
		if(fm_is_ent_visible(id, tid)){
			pev(tid, pev_velocity, Cvelocity)
			Cvelocity[0] += velocity[0]
			Cvelocity[1] += velocity[1]
			Cvelocity[2] += velocity[2]
			set_pev(tid, pev_velocity ,Cvelocity)

			pokedamage(tid, id, gust, Attack)

			client_print(tid, print_center, "You were hit by a %s", Attack)
			emit_sound(tid, CHAN_VOICE, SOUNDS[SND_JUMPLAND], 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
	}
 }
 
 Double_Slap(aid, id)
 {
	new slap = SLAP * PlayersLevel(aid, PlayersActive[aid])
	new Attack[32], damage

	if(ActivePoke(aid,POLIWRATH)){
		copy(Attack, 32, "Skullbash")
		damage = slap/SKULLBASH
	}
	else if(ActivePoke(aid, POLIWHIRL)){
		copy(Attack, 32, "Body Slam")
		damage = slap/BODY_SLAM
	}
	else{
		copy(Attack, 32, "Double Slap")
		damage = slap/DOUBLE_SLAP
	}

	if(damage<1)
		damage = 1

	new Float:velocity[3]
	velocity[0] = random_float(-1.0*slap, 1.0*slap)
	velocity[1] = random_float(-1.0*slap, 1.0*slap)
	velocity[2] = random_float(-1.0*slap, 1.0*slap)

	set_pev(id, pev_velocity, velocity)
	pokedamage(id, aid, damage, Attack)
 }
 Surf(id)
 {
	new level = PlayersLevel(id,PlayersActive[id])
	new Float:surf_origin[3]
	new surf_ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))
	set_pev(surf_ent, pev_classname, "pokemod_ent")
	set_pev(surf_ent, pev_owner, id)

	//lets use origin multiple times for the heck of not creating more variables (and im lazy)
	pev(id, pev_origin, surf_origin)
	engfunc(EngFunc_SetOrigin, surf_ent, surf_origin)

	pev(id, pev_angles, surf_origin)
	surf_origin[1] -=90			//my stupidity when making the model, so lets rotate it so it looks correct
	if(surf_origin[1]<-180)
		surf_origin[1] += 360
	surf_origin[0] = 0.0
	surf_origin[2] = 0.0
	set_pev(surf_ent, pev_angles, surf_origin)

	new while_time = 0
	velocity_by_aim(id, level*5, surf_origin)
	while(floatsqroot(surf_origin[0]*surf_origin[0] + surf_origin[1]*surf_origin[1])<level*5 && while_time<level){
		surf_origin[0] *= 1.1
		surf_origin[1] *= 1.1
		while_time++		//lets only do this so many times
	}
	surf_origin[2] = 0.0
	set_pev(surf_ent, pev_velocity, surf_origin)

	engfunc(EngFunc_SetModel, surf_ent, MODELS[MDL_SURF])
	set_pev(surf_ent, pev_scale, 1.0)

	set_pev(surf_ent, pev_movetype, MOVETYPE_NOCLIP)
	set_pev(surf_ent, pev_solid, SOLID_BBOX)

	set_pev(surf_ent, pev_maxs, Float:{100.0,100.0,30.0})
	set_pev(surf_ent, pev_mins, Float:{-100.0,-100.0,-30.0})

	bind_used(id, GYARADOS)

	set_task(0.1,"check_wave",surf_ent)
 }
 public check_wave(ent)
 {
	if(!pev_valid(ent))
		return
	new aid = pev(ent, pev_owner)

	new shortestDistance = 9999
	new distance, players[32], pnum
	new wave_dist = SURF_DISTANCE
	AddLvl(aid, wave_dist)

	// Find all alive enemies
	poke_get_players(players, pnum, "ag")
	new enemy

	// Find the closest enemy
	for (new i = 0; i < pnum; i++) {
		enemy = players[i]
		if(!pev_valid(ent))
			return
		if(!pev_valid(enemy))
			continue

		#if SURF_DUCK==1
		if(pev(enemy,pev_button)&IN_DUCK)
			continue
		#endif

		distance = fm_get_entity_distance(enemy, ent)

		if ( distance <= shortestDistance ) {
			shortestDistance = distance
		}
		if(distance<=wave_dist){
			surf_touch(ent, enemy)
		}
	}
	if( shortestDistance>9999 || (is_user_alive(aid) && pev_valid(ent) && fm_get_entity_distance(aid, ent)>1000)){
		if(pev_valid(ent))
			fm_remove_entity(ent)
		return
	}
	set_task(0.1, "check_wave", ent)
	emit_sound(ent, CHAN_VOICE, SOUNDS[SND_WADE], 0.5, ATTN_NORM, 0, PITCH_NORM)
 }
 Double_Team(id)
 {
	if(!PassTest(id, 0))
		return

	new teamate, Float:lastpercent = 1.00, lastid = 0, Float:percentage
	new players[MAX_PLAYERS], pnum
	poke_get_players(players, pnum, "aeg",Team(id))
	for(new i=0; i<pnum; i++){
		teamate = players[i]
		if(teamate==id)	//don't want to know about them
			continue

		percentage = float(Health(teamate))/float(maxhp[teamate])
		if(percentage<lastpercent){
			lastpercent = percentage
			lastid = teamate
		}
	}
	if(is_user_alive(lastid)){
		new Float:origin[3]
		pev(lastid, pev_origin, origin)
		origin[2] += 40	//set them above the player
		set_pev(id, pev_origin, origin)
		pev(lastid, pev_angles, origin)
		set_pev(id, pev_angles, origin)
		set_pev(id, pev_fixangle, 1)

		poke_UnStuck(id)
		bind_used(id, SCYTHER)
		soundcast(id)

		new name[32]
		get_user_name(lastid, name, 31)
		client_print(id, print_center, "You are double teaming with %s",name)
	}
	else{
		sounddeny(id)
		client_print(id, print_center, "You have no injured teammates")
		g_StopSkill[id] = true;
	}
 }
 
 Mist(id)
 {
	new aid, body
	get_user_aiming(id, aid, body)
	if(!is_user_alive(aid) || Team(aid)!=Team(id)){
		aid = id
	}

	new level = PlayersLevel(id, PlayersActive[id])
	new Float:mist_origin[3];
	pev(id, pev_origin, mist_origin)
	AoEdamage(id, mist_origin, level*10, clamp(-1*level/9,-100,-1), "Mist", 0)

	FVecIVec( mist_origin, origin[id] );

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
	write_byte(TE_SPRITE)
	write_coord(origin[id][0]) // start position
	write_coord(origin[id][1])
	write_coord(origin[id][2])
	write_short(gas) // sprite index
	write_byte(10) // scale in 0.1's
	write_byte(100) // brightness
	message_end()

	emit_sound(id, CHAN_VOICE, SOUNDS[SND_WADE], 1.0, ATTN_NORM, 0, PITCH_NORM)

	ResetStatus(aid)

	end_rep_use(id, ARTICUNO, 2.5)
 }
 
 Thunder(id)
 {
	bind_used(id,ZAPDOS)
	emit_sound(id, CHAN_VOICE, SOUNDS[SND_BIGGUN], 1.0, ATTN_NORM, 0, PITCH_NORM)

	new origin[3], toporigin[3], temporigin[3], Float:tempdist
	new aid, tid, x, damage = PlayersLevel(id, PlayersActive[id])
	new players[MAX_PLAYERS], pnum
	poke_get_players(players, pnum, "agi", Team(id))

	get_user_origin(id, origin)
	get_user_origin(id, toporigin)
	for(new i=0 ; i<5; i++){
		temporigin[0] = toporigin[0] + random_num(-1*damage, damage)
		temporigin[1] = toporigin[1] + random_num(-1*damage, damage)
		temporigin[2] = toporigin[2] + random_num(-1*damage, damage)
		MakeLine(0,origin,temporigin,lgtning,1,1,10,damage,damage,250,250,10,100,0)
	}

	for ( new i = 0; i < pnum; i++ )
	{
		aid = players[i]
		tempdist = fm_entity_range(id, aid)
		if(	(tempdist<1000 && (is_user_outside(id) || fm_is_ent_visible(id, aid)))
		||	(tempdist<2000 && fm_is_ent_visible(id, aid)))
		{
			get_user_origin(aid, origin)
			toporigin[0] = origin[0]
			toporigin[1] = origin[1]
			toporigin[2] = origin[2]+1000
			MakeLine(0,origin,toporigin,lgtning,1,1,10,damage*2,10,250,250,10,100,0)

			if(Health(aid)>1)
				pokedamage(aid, id, damage, "Thunder")
			client_print(aid, print_center, "You were hit by thunder")
			emit_sound(aid, CHAN_VOICE, SOUNDS[SND_SPARK], 1.0, ATTN_NORM, 0, PITCH_NORM)

			for ( x = 0; x < pnum; x++ )
			{
				tid = players[x]
				if(aid==tid)
					continue
				if(!fm_is_ent_visible(id,tid) && fm_is_ent_visible(aid, tid) && fm_entity_range(aid, tid)<500)
				{
					MakeLine_Ent(0,aid,tid,lgtning,1,1,10,damage,10,250,250,10,100,0)
					if(Health(tid)>5)
						pokedamage(tid, id, damage/4, "Thunder")
					client_print(tid, print_center, "You were hit by thunder")
					emit_sound(tid, CHAN_VOICE, SOUNDS[SND_SPARK], 1.0, ATTN_NORM, 0, PITCH_NORM)
				}
			}
		}
	}
 }
 Sky_Attack(id)
 {
	if(!PassTest(id, 0))
		return

	new teamate, lastid = 0, Float:lastdist = 999.9
	new players[MAX_PLAYERS], pnum
	poke_get_players(players, pnum, "agi",Team(id))
	for(new i=0; i<pnum; i++){
		teamate = players[i]

		if((is_user_outside(teamate) || fm_is_ent_visible(id, teamate)) && fm_entity_range(id,teamate)<lastdist){
			lastdist = fm_entity_range(id, teamate)
			lastid = teamate
		}
	}
	if(is_user_alive(lastid) && lastid!=id){
		new Float:delaytime = 5.0
		aim[id][0] = lastid
		aim[id][1] = lastid
		aim[id][2] = lastid
		new Float:tasktime = (delaytime*PlayersLevel(id,PlayersActive[id]))/(TotalLevels+1)
		set_task((delaytime-tasktime) + 1.0, "finish_Sky_Attack", id)

		new Float:origin[3]
		pev(id, pev_origin, origin)
		origin[2] += 10000
		set_pev(id, pev_origin, origin)

		//make their screen black (this makes it so the map isn't traced onto their screen)
		screenflash(id, 255, 255, 255, 255, 0.1)

		new name[32]
		get_user_name(lastid, name, 31)
		client_print(id, print_center, "Sky attacking %s...",name)
		soundcast(id)
		set_bind(id, WAIT_TIME)
	}
	else{
		sounddeny(id)
		client_print(id, print_center, "There is no enemy near you.")
		g_StopSkill[id] = true;
	}
 }
 public finish_Sky_Attack(id)
 {
	new checker = aim[id][0]
	//stop if their aim was reset, so these should all be the same
	if( !is_user_alive(id) || !checker || checker!=aim[id][1] || checker!=aim[id][2])
		return

	new lastid = checker

	new Float:temporigin[3]
	pev(lastid, pev_origin, temporigin)
	temporigin[2] += 40 //set them a little above the player
	set_pev(id, pev_origin, temporigin)
	pev(lastid, pev_angles, temporigin)
	set_pev(id, pev_angles, temporigin)
	set_pev(id, pev_fixangle, 1)

	poke_UnStuck(id)
	end_delay(id, MOLTRES)
	emit_sound(id, CHAN_VOICE, SOUNDS[SND_BIGGUN], 1.0, ATTN_NORM, 0, PITCH_NORM)

	client_print(lastid, print_center, "You have been sky attacked")

	new level = SKY_ATTACK_DAMAGE*PlayersLevel(id, PlayersActive[id])
	new radius = SKY_ATTACK_RADIUS + level

	new Float:attack_origin[3];
	pev(id, pev_origin, attack_origin)	//theoretically, they should be in lastid, but we don't want them to be
	AoEdamage(id, attack_origin, radius, level, "Sky Attack", 1, _, _, STATUS_BURN, 2)

	FVecIVec( attack_origin, origin[id] );

	// blast circles
	message_begin( MSG_PAS, SVC_TEMPENTITY, origin[id] )
	write_byte(TE_BEAMCYLINDER)
	write_coord( origin[id][0])
	write_coord( origin[id][1])
	write_coord( origin[id][2] - 16)
	write_coord( origin[id][0])
	write_coord( origin[id][1])
	write_coord( origin[id][2] - 16 + radius)
	write_short( fire )
	write_byte( 0 )		// startframe
	write_byte( 0 )		// framerate
	write_byte( 10 )		// life
	write_byte( 16 )	// width
	write_byte( 0 )		// noise
	write_byte( 188 )
	write_byte( 220 )
	write_byte( 255 )
	write_byte( 255 )	//brightness
	write_byte( 0 )		// speed
	message_end()
 }
 
 Psychic(id)
 {
	new level = PlayersLevel(id, HasPokemon(id, MEW));
	new damage = (level*PSYCHIC_DAMAGE)/(TotalLevels+1);

	new players[MAX_PLAYERS], pnum, tid;
	poke_get_players(players,pnum,"ai",Team(id));
	end_rep_use(id, MEW, 0.5);
	soundcast(id);
	g_StopSkill[id] = true;

	for(new i=0;i<pnum;i++){
		tid = players[i]
		if( fm_entity_range(id,tid) > (PSYCHIC_RANGE+level*5) )
			continue

		pokedamage(tid, id, damage, "Psychic")
		bind_used(tid, NONE, PSYCHIC_DELAY)

		get_user_origin(tid, origin[tid])

		message_begin( MSG_PAS, SVC_TEMPENTITY, origin[tid] )
		write_byte(TE_BEAMDISK)
		write_coord( origin[tid][0])
		write_coord( origin[tid][1])
		write_coord( origin[tid][2])
		write_coord( origin[tid][0])
		write_coord( origin[tid][1])
		write_coord( origin[tid][2] + 10 + level)
		write_short( shockwave )
		write_byte( 0 )		// startframe
		write_byte( 0 )		// framerate
		write_byte( 10 )		// life
		write_byte( 16 )	// width
		write_byte( 0 )		// noise
		write_byte( 188 )	//r
		write_byte( 20 )	//g
		write_byte( 188 )	//b
		write_byte( 255 )	//brightness
		write_byte( 0 )		// speed
		message_end()
	}
 }
 
 Psywave(id, aid, damage)
 {
	if(Chance(aid)){
		new percent_damage = LevelPercent(aid, damage, PlayersActive[aid])
		pokedamage(id, aid, percent_damage, "Psywave")

		MakeLine_Ent(0,id,aid,arbok,1,1,5,40,99,150,0,150,100,0)
	}
 }

 Quick_Attack(id)
 {
	new Float:velocity[3], Float:add_to[3]
	pev(id, pev_velocity, velocity)
	velocity_by_aim(id, QUICK_ATTACK+PlayersLevel(id,PlayersActive[id]), add_to)
	velocity[0] += add_to[0]
	velocity[1] += add_to[1]

	new flag =		pev(id, pev_flags)

	if(flag&FL_ONGROUND)
		velocity[2] = add_to[2]		//add some just so they get a little boost into the air
	else
		velocity[2] += floatclamp(add_to[2],0.0,40.0)	//if theyre in the air, dont force them upward
	set_pev(id, pev_velocity, velocity)

	end_rep_use(id, PIKACHU, 5.0)
 }
 
 Blizzard(id)
 {
	if(!task_exists(id+BLIZZARD_TASK)){
		new level = PlayersLevel(id, HasPokemon(id,JYNX))
		soundcast(id)
		set_bind(id, WAIT_TIME)
		make_snow(id)
		set_task(0.5, "Do_Blizzard", id+BLIZZARD_TASK, EMPTY, 0, "b")
		set_task(BLIZZARD_TIME+floatclamp(0.1*level,0.1,0.1*TotalLevels), "End_Blizzard", id)
	}
 }
 public End_Blizzard(id)
 {
	end_delay(id, JYNX)
	if(task_exists(id+BLIZZARD_TASK))
		remove_task(id+BLIZZARD_TASK)
 }
 public Do_Blizzard(id)
 {
	id -= BLIZZARD_TASK
	if(!is_user_alive(id)){
		if(task_exists(id+BLIZZARD_TASK))
			remove_task(id+BLIZZARD_TASK)
		return
	}

	new level = PlayersLevel(id, HasPokemon(id,JYNX))
	new players[MAX_PLAYERS], pnum, tid
	poke_get_players(players, pnum, "ag")

	for(new i=0; i<pnum; i++){
		tid = players[i]
		if( fm_entity_range(id,tid) > level*10 )
			continue

		make_snow(tid)
		if(Team(id)!=Team(tid)){
			ApplyStatus( id, tid, STATUS_FROZEN )
		}
	}
 }

 make_snow(id)
 {
	new vec[3]
	get_user_origin(id,vec)

	//lets put one on each side of them
	new sides[4][2]
	sides[0][0] = 100
	sides[0][1] = 100
	sides[1][0] = -100
	sides[1][1] = -100
	sides[2][0] = 100
	sides[2][1] = -100
	sides[3][0] = -100
	sides[3][1] = 100

	for(new i=0; i<4; i++){
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
		write_byte( TE_SPRITE ) // additive sprite, plays 1 cycle
		write_coord(vec[0] + sides[i][0] + random_num(-10,10))
		write_coord(vec[1] + sides[i][1] + random_num(-10,10))
		write_coord(vec[2])
		write_short( snow )
		write_byte( 14 ) // byte (scale in 0.1's)
		write_byte( 255 ) //  byte (brightness)
		message_end()
	}

	return PLUGIN_HANDLED
 }
 
 Thunder_Wave(id, aid)
 {
	if(Chance(id)){
		emit_sound(id, CHAN_VOICE, SOUNDS[SND_BIGGUN], 1.0, ATTN_NORM, 0, PITCH_NORM)
		MakeLine_Ent(0,id,aid,arbok,1,1,5,40,99,89,89,89,200,0)
		ApplyStatus( id, aid, STATUS_PARALYZE, THUNDER_WAVE_TIME )
		client_print(aid, print_center, "You were hit by a Thunder Wave")
	}
 }
 Dragon_Rage(id, aid, damage)
 {
	if(Chance(aid)){
		new percent_damage = LevelPercent(aid, clamp(damage,1,40), PlayersActive[aid])
		pokedamage(id, aid, percent_damage, "Dragon Rage")
		emit_sound(aid, CHAN_VOICE, SOUNDS[SND_AG_DIE], 1.0, ATTN_NORM, 0, PITCH_NORM)
		bind_used(aid, DRAGONAIR)
	}
 }
 Hyper_Beam(id)
 {
	new Attack[]= "Hyper Beam"

	new level = PlayersLevel(id, PlayersActive[id])
	new origin[3], aimvec[3], Float:f_origin[3], Float:f_aimvec[3]

	get_user_origin(id, origin)
	get_user_origin(id, aimvec, 2)
	IVecFVec(origin, f_origin)
	IVecFVec(aimvec, f_aimvec)

	Linedamage(id, f_origin, f_aimvec, level*2, level, Attack)
	MakeLine(0,origin,aimvec,zbeam6,1,1,1,level*20,0,255,255,255,255,0)
	emit_sound(id, CHAN_VOICE, SOUNDS[SND_AG_DIE], 1.0, ATTN_NORM, 0, PITCH_NORM)

	ApplyStatus( id, id, STATUS_PARALYZE, 5.0 )

	end_rep_use(id, DRAGONITE, 1.0)
 }
 Conversion(id)
 {
	fm_set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, CONVERSION_ALPHA)
	screenflash(id, 128, 128, 128, 128)
	SetSpeed(id)

	end_rep_use(id, PORYGON, 5.0+LevelPercent(id, CONVERSION_TIME, PlayersActive[id]))
 }
 Razor_Leaf(id)
 {
	new Attack[] = "Razor Leaf"
	new level = PlayersLevel(id,PlayersActive[id])
	new aimvec[3], Float:f_origin[3], Float:f_aimvec[3]

	get_user_origin(id, origin[id])
	get_user_origin(id, aimvec, 2)
	IVecFVec(origin[id], f_origin)
	IVecFVec(aimvec, f_aimvec)

	Linedamage(id, f_origin, f_aimvec, level/3, level*RAZOR_LEAF_FACTOR, Attack)

	new leafs = get_distance(origin[id], aimvec)/75

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)	//message begin
	write_byte(15)
	write_coord(origin[id][0])		// start position
	write_coord(origin[id][1])
	write_coord(origin[id][2])
	write_coord(aimvec[0])	// end position
	write_coord(aimvec[1])
	write_coord(aimvec[2])
	write_short(bigspit)		// sprite index
	write_byte(leafs)		// count
	write_byte(1)		// life in 0.1's
	write_byte(level/15)		// scale in 0.1's
	write_byte(5)		// velocity along vector in 10's
	write_byte(5)	// randomness of velocity in 10's
	message_end()

	emit_sound(id,CHAN_VOICE, SOUNDS[SND_STEP], 1.0, ATTN_NORM, 0, PITCH_NORM)

	end_rep_use(id, VICTREEBEL, 0.5)
 }
 
 Strength(id)
 {
	new ent, body;
	get_user_aiming(id, ent, body, STRENGTH_DIST);
	if(!pev_valid(PlayerEnt[id])){
		if(pev_valid(ent)){
			new class[32];
			pev(ent, pev_classname, class, 31);

			if(!equal(class, "worldspawn")
			&& !equal(class, "func_", 5)){
				if(is_user_alive(ent) && HeavyPoke(Pokemon[ent])){
					new pname[NAME_LENGTH];
					PokeToName(Pokemon[ent], pname);
					client_print(id, print_center, "%s is too heavy to pick up",pname);
					return;
				}
				PlayerEnt[id] = ent;
			}
			else{
				return;
			}
		}
		else
			return;
	}

	new Float:player_origin[3];
	new Float:ent_origin[3], Float:velocity[3];

	pev(id, pev_origin, player_origin);
	ent_origin[0] = player_origin[0];
	ent_origin[1] = player_origin[1];
	ent_origin[2] = player_origin[2];
	velocity_by_aim(id, STRENGTH_DIST/2, velocity);

	ent_origin[0] += velocity[0];
	ent_origin[1] += velocity[1];
	ent_origin[2] += velocity[2];

	engfunc(EngFunc_SetOrigin, PlayerEnt[id], ent_origin);

	#if STRENGTH_DAMAGE > 0
	if(is_user_alive(PlayerEnt[id]))
		pokedamage(PlayerEnt[id], id, STRENGTH_DAMAGE, "Strength");
	#endif
 }
 
 
 
 